
Require Export set10.
Require Export sete1.
Require Export sete2.

Set Implicit Arguments.
(* $Id: sete3.v,v 1.27 2010/06/08 17:16:36 grimm Exp $ *)

Module Exercise3.


(* Exercice 24 *)
Definition branched r :=
  order r & (forall x, inc x (substrate r) -> 
    exists y, exists z, gle r x y & gle r x z & 
      (forall t, gle r y t -> gle r z t -> False)).
    
Lemma Exercise1_24a: forall r, 
  order r -> anti_directed r ->  
  (forall x, inc x (substrate r) -> ~ maximal_element r x)
  -> branched r.
Proof. ir. split. am. ir. rwi (Exercise1_23h H) H0. nin H0.
  cp (H1 _ H2). assert (exists y, glt r x y).  app exists_proof. dneg.
  split. am. ir. nin (equal_or_not x0 x). am. elim (H5 x0). split; au.
  nin H5. nin (H0 _ _ H5). nin H6. exists x0. exists x1. nin H5; nin H6.
  split; au.
Qed.



(* Exercice 2.1 *)

Lemma induced_sub_pr1: forall r X x,
  (forall a b, gle r a b -> sub a b) ->
  upper_bound r X x -> sub (union X) x.
Proof. ir. red in H0. ee. red. ir. nin (union_exists H2). ee. cp (H1 _ H4).
 app (H _ _ H5).
Qed.

Lemma induced_sub_pr2: forall r X,
  order r ->
  (forall a b, inc a (substrate r) -> inc b (substrate r) ->
    (gle r a b = sub a b)) ->
  sub X (substrate r) -> inc (union X) (substrate r) ->
  least_upper_bound r X (union X).
Proof. ir. rww least_upper_bound_pr. split.
  red. ee. am. ir. rw H0. app union_sub. app H1. am. ir. rww H0.
  assert (forall a b, gle r a b -> sub a b). ir. wrr H0. order_tac. order_tac. 
  app (induced_sub_pr1 H4 H3). nin H3. am.
Qed.

Lemma inc_coarse: forall a b E, inc a E -> inc b E ->
  inc (J a b) (coarse E).
Proof. ir. uf coarse. aw. eee. Qed.

Lemma Exercise2_1a: forall r x y,
  order r -> inc x (substrate r) -> inc y (substrate r) ->
  ~ (gle r x y \/ gge r x y) -> 
  exists r', order r' & inc (J x y) r' & substrate r = substrate r' & sub r r'.
Proof. ir. set (E:= substrate r).
  set (a := union2 r (Zo (coarse E)(fun z=>  gle r (P z) x & gle r y (Q z)))).
  assert (is_graph a). red. ir. ufi a H3. nin (union2_or H3).
  assert (is_graph r). fprops. app H5. Ztac. ufi coarse H5.  awi H5. ee; am.  
  assert (E = substrate a). set_extens. assert (inc (J x0 x0) a). uf a.
  app union2_first.  change (gle r x0 x0). order_tac. substr_tac.
  rwi (inc_substrate_rw x0 H3) H4. ufi a H4; ufi coarse H4. 
  nin H4; nin H4; nin (union2_or H4). uf E. substr_tac. Ztac. awi H6;ee;am.  
  uf E. substr_tac. Ztac; awi H6;ee;am.
  assert (order a).  red. ee; split;tv. wr H4. ir.
  assert (gle r y0 y0). order_tac. red. uf a. app union2_first.
  ir. red in H5. red in H6. ufi a H5. ufi a H6. nin (union2_or H5).
  nin (union2_or H6). assert (inc (J x0 z) r). change (related r x0 z).
  app (order_transitivity H H7 H8). red. uf a; inter2tac.
  Ztac. awi H10. red. uf a. app union2_second. clear H8. Ztac. app inc_coarse.
  uf E. substr_tac. ufi coarse H9. awi H9. ee; am. aw. ee.
  assert (gle r x0 y0). am. order_tac. am. Ztac.  awi H9. clear H7.
  red. uf a. app union2_second. Ztac. app inc_coarse. nin H9. uf E. order_tac.
  rw H4. assert (inc (J y0 z) a). am. substr_tac. aw. ee. am.
  nin (union2_or H6).  change (gle r y0 z) in H10. order_tac. Ztac. awi H12.
  nin H12. elim H2. right. change (gle r y x). order_tac.
  ir. red in H5. red in H6. ufi a H5. ufi a H6. nin (union2_or H5).
  nin (union2_or H6). change (gle r x0 y0) in H7. change (gle r y0 x0) in H8.
  order_tac. Ztac. awi H10. change (gle r x0 y0) in H7. ee.
  assert (gle r y y0). order_tac.  assert (gle r y x). order_tac. elim H2. au.
  Ztac. clear H7. awi H9. nin (union2_or H6). ee. 
  change (gle r y0 x0) in H7.
  assert (gle r y x0). order_tac. assert (gle r y x). order_tac. elim H2. au.
  Ztac. awi H11. ee. assert (gle r y x).  order_tac. elim H2. au.
  exists  a. ee. am. uf a. app union2_second. Ztac. app inc_coarse. aw. 
  ee; order_tac. am. uf a. app union2sub_first.
Qed.

Definition set_of_orders x :=
  Zo (powerset (coarse x))(fun z => substrate z = x & order z).


Lemma set_of_orders_pr: forall x z,
  inc z (set_of_orders x) = (substrate z = x & order z).
Proof. ir. uf set_of_orders. app iff_eq. ir. Ztac. am. ir. Ztac. ee.
  app powerset_inc. wr H. app sub_graph_coarse_substrate. fprops.
Qed.

Definition finer_order_order x :=
  inclusion_suborder (set_of_orders x). 

Lemma order_finer_order: forall x,
  order (finer_order_order x).
Proof. ir. uf finer_order_order. app subinclusion_is_order.
Qed.

Lemma substrate_finer_order: forall x,
  substrate (finer_order_order x) = set_of_orders x.
Proof. ir. uf finer_order_order. app substrate_subinclusion_order.
Qed.

Hint Rewrite set_of_orders_pr substrate_finer_order : aw.
Lemma related_finer_order: forall x u v,
  related (finer_order_order x) u v = 
  (order u & order v & substrate u = x & substrate v = x & sub u v).
Proof. ir. uf finer_order_order. rw subinclusion_order_rw. aw. 
  ap iff_eq; ir; intuition. 
Qed.

Lemma related_finer_order1: forall x u v,
  related (finer_order_order x) u v = 
  (order u & order v & substrate u = x & substrate v = x &
  forall a b, inc a x -> inc b x -> gle u a b -> gle v a b).
Proof. ir.  uf gle.  rw related_finer_order. ap iff_eq. ir. eee.
  ir. uf related. ufi related H6. app H3.
  ir. eee. red. ir. assert (is_graph u). fprops.
  assert (is_pair x0). app H5. assert (J (P x0) (Q x0) = x0). aw.
  wri H7 H4. assert (inc (P x0) x). wr H1.  substr_tac. 
  assert (inc (Q x0) x). wr H1. substr_tac.
  ufi related H3. wr H7. ap (H3 _ _ H8 H9 H4). 
Qed.

Lemma Exercise2_1b: forall E a,
  maximal_element (finer_order_order E) a = (total_order a & substrate a = E).
Proof. ir. ap iff_eq. ir. nin H. awi H. ee. split. am.
  ir.  nin (p_or_not_p(gle a x y \/ gge a x y)). am.
  nin (Exercise2_1a H1 H2 H3 H4).
  assert (gle (finer_order_order E) a x0). rw related_finer_order. eee.
  cp (H0 _ H6). elim H4. left. ee. wrr H7. am.

  ir. red. split. aw. nin H. nin H. au. ir. rwi related_finer_order1 H0. ee.
  rw graph_extensionality. ir. ap iff_eq. ir.
  assert (inc u E). wr H3. substr_tac. assert (inc v E). wr H3. substr_tac.
  cp H7; cp H8.  nin H.  wri H2 H7; wri H2 H8. nin (H11 _ _ H7 H8). am.
  cp (H4 _ _ H10 H9 H12). change (gle x u v) in H6. change (gle x v u) in H13.
  assert (u = v). order_tac. rw H14. order_tac.
  ir. app H4. wr H2. substr_tac. wr H2. substr_tac. fprops. fprops.
Qed.

Lemma inductive_finer_order: forall E, inductive_set (finer_order_order E).
Proof. ir. red. ir. nin (emptyset_dichot X).
  exists (diagonal E). split. ee. aw. ee. rww substrate_diagonal.
  app diagonal_order. ir. rwi H1 H2. elim (emptyset_pr H2).
  nin H1. cp (H _ H1). awi H2. nin H2.
  exists (union X).  set (r:=finer_order_order E) in *.
  assert (order r). uf r. app order_finer_order.
  assert (forall a b, inc a (substrate r) -> inc b (substrate r) ->
    (gle r a b = sub a b)). ir. uf r. rw related_finer_order.
  ap iff_eq. ir. ee. am. ufi r H5. awi H5. ufi r H6. awi H6. ee. ir. au.
  assert (is_graph (union X)). red. ir. nin (union_exists H6). ee.
  cp (H _ H8). ufi r H9. awi H9. nin H9. assert (is_graph x). fprops. app H11.
  assert(substrate (union X) = E).
  set_extens. ufi substrate H7. nin (union2_or H7). awi H8. nin H8.
  nin (union_exists H8). ee. cp (H _ H10). ufi r H11. awi H11. nin H11. wr H11.
  substr_tac. am. awi H8. nin H8.  nin (union_exists H8). ee. 
  cp (H _ H10). ufi r H11. awi H11. nin H11. wr H11. substr_tac. am.
  wri H2 H7. assert (inc (J x x) y).  order_tac.
  assert (inc (J x x) (union X)). union_tac. substr_tac.
  assert (inc (union X) (substrate r)). uf r. aw. ee. am.
  red. ee; split;tv. rw H7. ir. red. assert (inc (J y0 y0) y).
  wri H2 H8. order_tac. union_tac. ir. red in H8. red in H9.
  nin (union_exists H8). nin (union_exists H9). ee.
  nin H0. awii H14. nin (H14 _ _ H12 H13). ufi r H15. awii H15.
  rwi related_finer_order1 H15. ee.
  change (gle x0 x y0) in H10. assert (inc y0 E).  wr H17. substr_tac.
  assert (inc z E).  wr H17. substr_tac. cp (H19 _ _ H20 H21 H11).
  assert (gle x0 x z). order_tac. red in H23. red in H23. red. union_tac.
  change (gle (induced_order r X) x0 x1) in H15.  ufi r H15. awii H15.
  rwi related_finer_order1 H15. ee.
  change (gle x1 y0 z) in H11. assert (inc x E).  wr H17. substr_tac.
  assert (inc y0 E).  wr H17. substr_tac. cp (H19 _ _ H20 H21 H10).
  assert (gle x1 x z). order_tac. red in H23. red in H23. red. union_tac. 
  ir. red in H8. red in H9.
  nin (union_exists H8). nin (union_exists H9). ee.
  nin H0. awii H14. nin (H14 _ _ H12 H13). ufi r H15. awii H15.
  rwi related_finer_order1 H15. ee.
  change (gle x0 x y0) in H10. assert (inc y0 E).  wr H17. substr_tac.
  assert (inc x E).  wr H18. order_tac. cp (H19 _ _ H20 H21 H11). order_tac.
  change (gle (induced_order r X) x0 x1) in H15.  ufi r H15. awii H15.
  rwi related_finer_order1 H15. ee.
  change (gle x1 y0 x) in H11. assert (inc x E).  wr H17. substr_tac.
  assert (inc y0 E).  wr H17. substr_tac. cp (H19 _ _ H20 H21 H10). order_tac.
  cp (induced_sub_pr2 H4 H5 H H8).
  rwi least_upper_bound_pr H9. ee. am. am. am.
Qed.

Lemma order_total_extension: forall r, order r ->
  exists r', total_order r' & substrate r' = substrate r & sub r r'.
Proof. ir. set (E:= substrate r). set (R:= finer_order_order E).
  assert (order R). uf R. app order_finer_order.
  assert (inductive_set R). uf R. app inductive_finer_order.
  assert (inc r (substrate R)). uf R. aw. au.
  nin (inductive_max_greater H0 H1 H2). ufi R H3.  nin H3.
  rwi Exercise2_1b H3. exists x. eee. rwi related_finer_order H4. ee; am.
Qed.

Lemma Exercise2_1c: forall r, 
 order r -> r = intersection (Zo (set_of_orders (substrate r))
   (fun r' => total_order r' & sub r r')).
Proof. ir. set (bs:= Zo (set_of_orders (substrate r))
   (fun r' => total_order r' & sub r r')).
  nin (order_total_extension H). assert (inc x bs). uf bs. Ztac. aw. ee. am.
  nin H0. am. ee; am. set_extens. app intersection_inc. ex_tac.
  ir. ufi bs H3. Ztac. nin H5. app H6. cp (intersection_forall H2 H1).
  ufi bs H1.  Ztac. clear H1. nin H5.
  assert (is_pair x0). assert (is_graph x). nin H1. fprops. fprops.
  assert (x0 = J (P x0) (Q x0)). aw. awi H4. nin H4.
  assert (inc (P x0) (substrate r)). wr H4. rwi H7 H3. substr_tac.
  assert (inc (Q x0) (substrate r)). wr H4. rwi H7 H3. substr_tac.
  nin (equal_or_not (P x0) (Q x0)). rw H7. rw H11. order_tac.
  nin (p_or_not_p (gle r (Q x0) (P x0) \/ gge r (Q x0) (P x0))). nin H12.
  ee.  red in H12. red in H12. cp  (H5 _ H12). rwi H7 H3. elim H11. order_tac.
  red in H12. red in H12.  rww H7.
  nin (Exercise2_1a H H10 H9 H12). ee.
  nin (order_total_extension H13). ee.
  assert (inc x2 bs). uf bs. Ztac. aw. ee. ue. nin H19. am. ee. am.
  apply sub_trans with x1. am. am. cp (intersection_forall H2 H22).
  cp (H21 _ H14).  rwi H7 H23. elim H11. nin H19. order_tac.
Qed.

Lemma Exercise2_1d: forall r, order r -> exists f, exists g, exists h,
  axioms_product_order f g &
  (forall i, inc i (domain f) -> total_order (V i g)) &
  order_morphism h r (product_order f g).
Proof. ir. cp  (Exercise2_1c H).
  set (bs :=  Zo (set_of_orders (substrate r))
    (fun r' => total_order r' & sub r r')) in H0.
  set (f:= L bs (fun _: Set => (substrate r))).
  set (g:= L bs (fun z: Set => z)).
  assert (axioms_product_order f g). red. uf f; uf g. ee. gprops. gprops. bw.
  bw. ir. ufi bs H1. Ztac.  nin H3. nin H3. bw. bw. ir. ufi bs H1. Ztac. 
  awi H2. nin H2. bw.
  assert(forall i, inc i (domain f) -> total_order (V i g)). uf f. uf g.
  bw. ir.  ufi bs H2. Ztac. nin H4. bw.
  set (h := BL (fun x => L bs (fun _:Set => x)) (substrate r) (productb f)).
  nin (order_total_extension H). assert (inc x bs). uf bs. Ztac. aw. ee. am. 
  nin H3. am. ee. am. am.
  exists f. exists g. exists h. ee. am. am.
  assert (transf_axioms  (fun x : Set => L bs (fun _ : Set => x))
    (substrate r) (productb f)).
  red. ir. uf f. rw productb_pr. bw. ee. gprops. tv. ir. bw.  gprops.
  red. eee. uf h. app injective_af_function. ir.
  cp (f_equal (fun  f=> V x f) H10). simpl in H11. bwi H11. am. am. am.
  ir. rww substrate_product_order. uf h. simpl. bw. ir. aw.
  uf f; uf g. ap iff_eq. ir. ee. app H7. app H7. ir. bwi H11. bw. 
  ufi bs H11. Ztac. nin H13. red. app H14.
  bw. ir. ee. red. red. rw Exercise2_1c. fold bs. app intersection_inc.
  ex_tac. ir. cp (H12 _ H13). bwi H14. am. am. am. am. am.    
Qed.


(* Exercise 2 *)

Lemma Exercise2_2a : forall r,
  let B:= Zo (powerset (substrate r)) (fun z=> worder (induced_order r z)) in
    let ss_order := Zo (coarse B)
      (fun z=> is_segment (induced_order r (Q z)) (P z)) in
      order r ->
      (order ss_order & substrate ss_order = B & inductive_set ss_order).
Proof. ir.
  assert (Ha: forall x y,  related ss_order x y = 
    (inc x B & inc y B & is_segment (induced_order r y) x)).
  ir. uf ss_order. uf related. ap iff_eq. ir. Ztac. awi H1. awi H2.
  ufi coarse H1. awi H1. eee. ir. ee. Ztac. app inc_coarse. aw.
  assert (Hb: is_graph ss_order). uf ss_order. red. ir. Ztac.  ufi coarse H1.
  awi H1. ee. am.
  assert (Hc: forall x y, related ss_order x y -> sub x y). ir.
  rwi Ha H0. ee. red in H2. ee. awi H2. am. am.  ufi B H1. Ztac.
  rwi powerset_inc_rw H4. am.
  assert (Hd: forall x, inc x B ->gle ss_order x x).
  ir.  rw Ha. eee. red.  ufi B H0. Ztac. rwi powerset_inc_rw H1. ee. aw.
  fprops. ir. nin (related_induced_order3 H4). am. 
  assert(He:substrate ss_order = B). set_extens. ufi substrate  H0.
  nin (union2_or H0). awi H1.  nin H1. change (related ss_order x x0) in H1.
  rwi Ha H1. ee. am. am. awi H1. nin H1. change (related ss_order x0 x) in H1.
  rwi Ha H1. ee. am. am. assert (inc (J x x) ss_order). app Hd. substr_tac.
  assert (Hf: forall x, inc x B -> sub x (substrate r)). uf B. ir. Ztac.
  rwi powerset_inc_rw H1. am.
  assert (order ss_order). red. ee; split; tv. rw He. exact Hd. 
  ir. rwi Ha H0; rwi Ha H1; rw Ha. eee. red in H5; red in H3. ee.
  awii H5. awii H3. red. ee. aw. apply sub_trans with y. am. am.  app Hf.
  ir. cp (H6 _ _ (H5 _ H8) H9).  cp (H5 _ H8). 
  assert (gle (induced_order r y) y0 x0). aw. ap (related_induced_order1 H9).
  ap (H7 _ _ H8 H12).  app Hf. app Hf. 
  ir. app extensionality. app Hc. app Hc. eee.
  red. ir. rwi He H1. assert (sub  (union X) (substrate r)).
  red. ir.  nin (union_exists H3). ee. cp (H1 _ H5). ufi B H6. Ztac.
  rwi powerset_inc_rw  H7. app H7.
  assert (worder (induced_order r (union X))). split. fprops.
  ir. awii H4. nin H5. cp (H4 _ H5). nin (union_exists H6). ee.
  set (Z := intersection2 x x0). assert (nonempty Z). exists y.
  uf Z. app intersection2_inc. cp (H1 _ H8). ufi B H10. Ztac.
  assert (sub Z x0). uf Z.  app intersection2sub_second.
  assert (sub x0 (substrate r)). app Hf.
  assert (sub Z (substrate r)). apply sub_trans with x0; am.
  nin H12. assert (sub Z (substrate (induced_order r x0))). aw. 
  nin (H16 _ H17 H9). wrii induced_trans H18. red in H18.  awii H18. nin H18.
  exists x1. wrr induced_trans. red. 
  assert (inc x1 x).  ufi Z H18. inter2tac. 
  aw. split.  am. ir. aw.  cp (H4 _ H21). nin (union_exists H22). ee.
  nin H2. awii H25. nin (H25 _ _ H24 H8). 
  cp ((Hc _ _ (related_induced_order1 H26)) _ H23). assert (inc x2 Z).
  uf Z. app intersection2_inc. cp (H19 _ H28). ap (related_induced_order1 H29).
  red in H26. cp (related_induced_order1 H26). cp ((Hc _ _ H27) _ (H13 _ H18)).
  rwi Ha H27. ee. red in H30. ee. ufi B H29. Ztac. cp (worder_total H33). 
  nin H34. awi H35. nin (H35 _ _ H28 H23).  ap (related_induced_order1 H36).
  cp (H31 _ _  (H13 _ H18) H36). assert (inc x2 Z). uf Z. app intersection2_inc.
  cp (H19 _ H38). ap (related_induced_order1 H39). am. app Hf. rww He.
  apply sub_trans with (union X). am. am.
  assert (inc (union X) B). uf B. Ztac. app powerset_inc. eee.

  exists (union X). split. rww He. red. ir. rw Ha. eee. red. aw. ee.
  app union_sub. ir. cp (related_induced_order1 H8).
  nin (related_induced_order3 H8). nin H2. awi H12. 
  nin (union_exists H10). nin H13. nin (H12 _ _ H14 H6).
  cp (related_induced_order1 H15). app (Hc _ _ H16). 
  cp (related_induced_order1 H15). rwi Ha H16. ee. red in H18. ee.
  assert (gle (induced_order r x0) y0 x). aw. awi H18. app H18. am. app Hf.
  ap (H19 _ _ H7 H20). am. rww He.
Qed.

Lemma Exercise2_2b : forall r, order r ->
  exists x, sub x (substrate r) &  worder (induced_order r x) &
    forall z, upper_bound r x z -> inc z x.
Proof. ir. cp  (Exercise2_2a H). 
  set (B:= Zo (powerset (substrate r)) (fun z=> worder (induced_order r z))) in
    H0. 
  set (ss_order := Zo (coarse B) 
    (fun z=> is_segment (induced_order r (Q z)) (P z))) in H0. 
  ee. nin (Zorn_lemma H0 H2). red in H3. ee. exists x. rwi H1 H3. ufi B H3.
  Ztac. clear H3.  rwi powerset_inc_rw H5. eee. ir.
  set (y:= tack_on x z). assert (sub y (substrate r)). uf y. red. ir. 
  rwi tack_on_inc H7. nin H7. app H5. rw H7. nin H3. am. 
  cut (gle ss_order x y). ir. wr (H4 _ H8). uf y.  fprops. 
  red. red. uf ss_order. Ztac. uf coarse. aw. ee. fprops. uf B. Ztac. 
  app powerset_inc. uf B. Ztac. app powerset_inc. red. ee. fprops. aw.
  ir. set (t:= intersection2 x0 x). 
  assert (Ha: sub t x). uf t. app intersection2sub_second. 
  assert (Hb: sub t y).  apply sub_trans with x0. uf t. 
  app intersection2sub_first.  am.
  assert (Hc: sub t (substrate r)). apply sub_trans with y. am. am.
  assert (Hd: sub x0 (substrate r)). apply sub_trans with y. am. am.
  nin (emptyset_dichot t). nin H9. assert (forall u, inc u x0 -> u = z).
  ir. cp (H8 _ H11).  ufi y H11. ufi y H12. rwi tack_on_inc H12. nin H12. 
  elim (emptyset_pr (x:=u)). wr H10. uf t. app intersection2_inc. am. 
  assert (x0 = singleton z). set_extens. rw (H11 _ H12). fprops. awi H12. 
  rw H12. wrr (H11 _ H9). exists z. wrr induced_trans. red. aw. ee.
  rw H12. fprops. ir.  aw. rw (H11 _ H13).  order_tac. nin H3. am. rw H12.
  fprops. nin H6. awii H11.
  nin (H11 _ Ha H10). exists x1. wrii induced_trans H12. nin H12.
  awii H12. awii H13. wrr induced_trans. split. aw. ufi t H12.  inter2tac. 
  ir. awii H14. aw. nin (equal_or_not x2 z). rw H15. nin H3. app H16. app Ha.
  assert (inc x2 t).  uf t. app intersection2_inc. cp (H8 _ H14). ufi y H16.
  rwi tack_on_inc H16. nin H16. am. contradiction. cp (H13 _ H16).
  ap (related_induced_order1  H17). ufi t H12. inter2tac.
  aw. red. aw. ee.  uf y. fprops. ir. nin H3.
  nin (related_induced_order3 H9). ufi y H11. rwi tack_on_inc H11. nin H11. am.
  rw H11. cp (related_induced_order1 H9). rwi H11 H13. cp (H10 _ H8).
  assert (z = x0). order_tac. rww H15.
Qed.

(* Exercise 3 *)
Lemma Exercice2_3: forall r, order r -> exists B, 
  sub B (substrate r) & 
  worder (induced_order r (complement (substrate r) B)) &
  (forall y, ~ (least_element (induced_order r B) y)).
Proof. ir.
  set (no_least := fun B =>forall y, ~ least_element (induced_order r B) y).
  set (B:= union (Zo (powerset (substrate r)) no_least)).
  assert (sub B (substrate r)). red. ir.
  nin (union_exists H0). nin H1. Ztac. rwi powerset_inc_rw H3. app H3.
  exists B. ee. am. assert (sub (complement (substrate r) B) (substrate r)).
  app sub_complement. split. fprops. aw. ir. wrr induced_trans.
  nin (p_or_not_p (exists y, least_element (induced_order r x) y)). am.
  assert (sub x B). red. ir. uf B. apply union_inc with x. am. Ztac.
  app powerset_inc. red. ir. cp (H2 _ H6). srwi H7. ee. am. red. ir.
  dneg. exists y. am. nin H3. cp (H2 _ H3). srwi H6. nin H6. elim H7. app H5.
  ir. red. ir. nin H1. awii H1. awii H2. ufi B H1. nin (union_exists H1).
  nin H3. Ztac. rwi powerset_inc_rw H5. elim (H6 y). split. aw. aw.
  ir. aw. assert (inc x0 B). uf B. union_tac. cp (H2 _ H8). awii H9.
Qed.

(* Exercise 4*)

Lemma Exercice2_4: forall r, order r -> 
  let  pworder :=  fun F => forall X,
    sub X F -> total_order (induced_order r X) -> worder (induced_order r X)
    in  exists F, (pworder F & cofinal_set r F).
Proof. ir. set (FF:= Zo (powerset (substrate r)) pworder).
  set (r' := graph_on (fun x y => sub x y & forall a b, inc a x ->
    inc b (complement y x) -> ~ (gle r b a)) FF). 
  set (f:= fun x y => forall a b, inc a x ->
    inc b (complement y x) -> ~ gle r b a).
  assert (forall x y, related r' x y = (inc x FF & inc y FF & sub x y & f x y)).
  ir. uf r'. uf graph_on. uf related. ap iff_eq. ir. Ztac. awi H2. awi H1. 
  eee. ir. ee.  Ztac. aw. fprops. aw. eee. 
  assert (Hp: forall F, sub F (substrate r) ->  pworder F = 
    (forall X, sub X F -> nonempty X -> total_order (induced_order r X) 
      -> exists y, least_element (induced_order r X) y)). 
  ir. ap iff_eq. ir. cp (H2 _ H3 H5). nin H6.  cp (sub_trans H3 H1).
  awii H7. assert (sub X X). fprops. nin (H7 _ H9 H4).
  wrii induced_trans H10. exists x. am. ir. red. ir. cp (sub_trans H3 H1).
  split. fprops. ir. awi H6. cp (sub_trans H6 H3). 
  assert (total_order (induced_order r x)).  nin H4. awii H9. ee.
  cp (sub_trans H8 H1). split. fprops. aw. ir.
  cp (H6 _ H11). cp (H6 _ H12). ufi gge H9. aw. nin (H9 _ _ H13 H14); awi H15.
  au. am. am. right. uf gge.  aw. am. am. nin (H2 _ H8 H7 H9). exists x0.
  wrr induced_trans. am. am.
  assert (Hf: forall x F, inc x (substrate r) -> inc F FF ->
    inc (tack_on F x) FF).
  ir. ufi FF H2. Ztac. clear H2. rwi powerset_inc_rw H3. rwii Hp H4.
  assert (sub (tack_on F x) (substrate r)). red. ir. rwi tack_on_inc H2. 
  nin H2. app H3. rww H2. uf FF. Ztac. app powerset_inc. rww Hp. ir.
  assert (Hs:=sub_trans H5 H2). nin (inc_or_not x X).  
  nin (equal_or_not X (singleton x)).  exists x. split. aw.  aw. ir. aw. 
  rwi H9 H10. awi H10. rw H10. order_tac. 
  set (Y := intersection2 X F). assert (sub Y F). uf Y. 
  app intersection2sub_second. 
  nin (emptyset_dichot Y). elim H9. set_extens. cp (H5 _ H12).
  rwi tack_on_inc H13. nin H13. elim (emptyset_pr (x:=x0)).
  wr H11. uf Y. app intersection2_inc. ue. awi H12. rww H12.
  assert (sub Y X). uf Y.  app intersection2sub_first. cp (sub_trans H10 H3).
  assert (total_order (induced_order r Y)).
  split. fprops. aw. nin H7. awii H14. ir. uf gge. aw. ufi gge H14. 
  cp (H12 _ H15). cp (H12 _ H16). nin (H14 _ _ H17 H18); awi H19; au.
  nin (H4 _ H10 H11 H14).
  assert (exists z, inc z X & gle r z x & gle r z x0).
  nin H15. awii H15. ufi Y H15. cp (intersection2_first H15). nin H7.
  awii H18. ufi gge H18. nin (H18 _ _ H8 H17); awi H19.  exists x. eee.
  order_tac. am. am. exists x0. eee. order_tac. order_tac. am. am. 
  nin H16. ee. exists x1. split. aw. aw. ir. aw. nin H15. awi H20.
  cp (H5 _ H19). rwi tack_on_inc H21. nin H21. assert (inc x2 Y).
  uf Y. app intersection2_inc. cp (H20 _ H22). 
  cp (related_induced_order1 H23). order_tac. rww H21. am. am. app H4.
  red. ir. cp (H5 _ H9). rwi tack_on_inc H10. nin H10. am. elim H8. ue.
  assert (order r'). uf r'. app order_from_rel. red. ee; red; ir; ee.
  apply sub_trans with y. am. am. ir. srwi H6. nin H6.
  nin (inc_or_not b y). app H4. srw. eee. app H3. app H1. srw. eee. 
  app extensionality. fprops. ir. srwi H4.
  nin H4; contradiction. fprops. ir. srwi H4. nin H4; contradiction.
  assert (substrate r' = FF). rw substrate_domain_order.
  set_extens. awi H2. nin H2. ufi related H0. rwi H0 H2. ee; am. fprops.
  aw. exists x. ufi related H0. rw H0. eee. uf f. ir. srwi H4. 
  nin H4; contradiction. fprops. am. 
  assert (inductive_set r'). red. ir. nin H4. awii H5. 
  assert (sub (union X) (substrate r)).  red. ir.
  nin (union_exists H6). nin H7. cp (H3 _ H8). rwi H2 H9. ufi FF H9. Ztac.
  rwi powerset_inc_rw H10. app H10.
  assert (inc (union X) FF). uf FF. Ztac. app powerset_inc. red. ir.
  cp (sub_trans H7 H6). split. nin H8. am. ir. awii H10. nin H11. 
  cp (H10 _ H11). cp (H7 _ H12). nin (union_exists H13). nin H14. 
  wrr induced_trans. 
  set (K:=intersection2 x x0). cp (H3 _ H15). rwi H2 H16. ufi FF H16.
  Ztac. assert (sub K x0). uf K. app intersection2sub_second.
  assert (sub K X0). apply sub_trans with x. uf K. app intersection2sub_first. 
  am. cp (sub_trans H20 H9).
  assert (total_order (induced_order r K)). split. fprops. aw. ir. nin H8. 
  awii H24. uf gge. aw. cp  (H20 _ H22). cp (H20 _ H23). nin (H24 _ _ H25 H26). 
  awii H27. au. ufi gge H27.  awii H27. au. cp (H18 _ H19 H22). 
  nin H23. awii H24. assert (sub K K). fprops. assert (nonempty K). exists  y. 
  uf K. app intersection2_inc. cp (H24 _ H25 H26). nin H27. 
  wrii induced_trans H27. nin H27. awii H27. awii H28. cp (sub_trans H10 H9). 
  exists x1. split. aw. ufi K H27. inter2tac. ir. awii H30. aw.
  cp (H10 _ H30). cp (H7 _  H31).  nin (union_exists H32). nin H33.
  nin (inc_or_not x2 x0).  assert (inc x2 K). uf K. app intersection2_inc.
  cp (H28 _ H36). awii H37. nin (H5 _ _ H34 H15). awii H36. rwi H0 H36. ee. 
  elim H35. app H38. ufi gge H36. awii H36.  rwi H0 H36. ee. ufi f H39.
  cp (H19 _ H27). assert (inc x2 (complement x3 x0)). srw. ee. am. am.
  cp (H39 _ _ H40 H41). nin H8. awii H43. cp (H20 _ H27). nin (H43 _ _ H31 H44).
  awii H45. contradiction. red in H45. awii H45. ufi K H27. inter2tac.
  exists (union X). split. ue. ir. rw H0. ee. wr H2. app H3. am. app union_sub.
  uf f. ir. srwi H10. nin H10. nin (union_exists H10). nin H12.
  nin (H5 _ _ H8 H13). awii H14. rwi H0 H14. ee. ufi f H17. app H17.
  srw. eee. ufi gge H14.  awii H14. rwi H0 H14. ee. elim H11. app H16.
  nin (Zorn_lemma H1 H3). nin H4. rwi H2 H4. cp H4. ufi FF H4. Ztac.
  rwi powerset_inc_rw H7. clear H4. exists x. split. am. split. am. 
  ir. nin (inc_or_not x0 x). exists x0. ee. am. order_tac.
  app exists_proof. red. ir. assert (gle r' x (tack_on x x0)). rw H0. ee. am. 
  app Hf. fprops. uf f. ir. srwi H12. red. ir. elim (H10 a). ee. am. 
  rwi tack_on_inc H12. nin H12. contradiction. ue.
  cp (H5 _ H11). elim H9. wr H12. fprops.
Qed.
 
(* Exercise 5 *)
Lemma Exercise2_5: forall r, order r -> inductive_set r ->
  exists x, greatest_element (free_subset_order r) x.
Proof. ir. set (A:= Zo (substrate r) (maximal_element r)).
  assert (free_subset r A). red. ir. ufi A H1. Ztac. nin H5. sy. app H6.
  assert (inc A (set_of_free_subsets r)). uf set_of_free_subsets. Ztac. 
  app powerset_inc. uf A. app Z_sub.
  cp (fs_is_order H). cp (substrate_fs_order H). 
  exists A. split. ue. rw H4. ir. rw fs_order_pr. red. eee.
  ir. ufi set_of_free_subsets H5. Ztac. rwi powerset_inc_rw H7. 
  nin (inductive_max_greater H H0 (H7 _ H6)). 
  exists x1. ee. uf A. clear H5. Ztac. order_tac. am.
Qed.

(* Exercise 6 *)

Definition Ex2_6S r f :=
  Zo (powerset (substrate r))
  (fun M => (forall x, inc x M -> inc (W x f) M) &
    (forall N x, sub N M -> nonempty N -> least_upper_bound r N x -> inc x M)).

Definition Ex2_6chain r f a :=
  intersection (Zo (Ex2_6S r f) (fun z => inc a z)).

Definition Ex2_6H r f := order r & is_function f & substrate r = source f 
  & substrate r = target f & forall x, inc x (substrate r) -> gle r x (W x f).

Lemma Exercise2_6a: forall r f, Ex2_6H r f ->
  (inc (substrate r) (Ex2_6S r f)). 
Proof. ir. uf Ex2_6S. Ztac. app powerset_inc. fprops. ee. red in H. ee.
  ir. rwi H1 H4. rw H2. fprops. ir. nin H2.  awi H2. Ztac. am.
  nin H. am. app Z_sub.
Qed.

Lemma Exercise2_6b: forall r f a, Ex2_6H r f ->
  inc a (source f) -> nonempty (Zo (Ex2_6S r f) (fun z => inc a z)).
Proof. ir. exists (substrate r). Ztac. app Exercise2_6a.
  red in H. ee. ue.
Qed.

Lemma Exercise2_6c: forall r f a, Ex2_6H r f ->
  inc a (source f) -> inc a (Ex2_6chain r f a).
Proof. ir. uf Ex2_6chain. app intersection_inc. app Exercise2_6b.
  ir. Ztac. am.
Qed.


Lemma Exercise2_6d: forall r f a, Ex2_6H r f ->
  inc a (source f) -> inc (Ex2_6chain r f a) (Ex2_6S r f).
Proof. ir. cp (Exercise2_6b H H0). uf Ex2_6S. Ztac. app powerset_inc. 
  uf Ex2_6chain. red. ir. nin H1. cp (intersection_forall H2 H1).  Ztac.
  ufi Ex2_6S H4. Ztac. rwi powerset_inc_rw H6. app H6.
  ee. ir. uf Ex2_6chain. app intersection_inc. ir. Ztac. ufi Ex2_6S H4. Ztac. 
  nin H7. app H7. ap (intersection_forall H2 H3). ir. uf Ex2_6chain. 
  app intersection_inc. ir. Ztac. ufi Ex2_6S H6. Ztac. 
  nin H9. assert (sub N y). red. ir. cp (H2 _ H11).
  ufi Ex2_6chain H12. ap (intersection_forall H12 H5). app (H10 _ _ H11 H3 H4).
Qed.

Lemma Exercise2_6e: forall r f a b, Ex2_6H r f ->
  inc a (source f) -> least_upper_bound r  (Ex2_6chain r f a) b ->
  (inc b  (Ex2_6chain r f a) & W b f = b).
Proof. ir. cp (Exercise2_6c H H0). cp (Exercise2_6d H H0). 
  set (s:= Ex2_6chain r f a) in *.
  ufi Ex2_6S H3. Ztac. nin H5. assert (sub s s). fprops.
  assert (nonempty s). exists a. am. assert (inc b s). app (H6 _ _ H7 H8 H1).
  split. am. Ztac. rwi powerset_inc_rw H10.
  cp (H5 _ H9). red in H. ee. awii H1. nin H1. nin H1. 
  cp (H19 _ H12). cp (H17 _ H1). order_tac.
Qed.

Lemma Exercise2_6f: forall r, worder r ->
  nonempty (substrate r) -> exists x,
    (inc x (substrate r) & segment r x = emptyset).
Proof. ir. nin H.  set (x:= substrate r) in H0.
  assert (sub x (substrate r)). uf x. fprops. cp (H1 _ H2 H0).
  nin H3.  nin H3. awii H3; awii H4. exists x0. ee. am.
  app is_emptyset. ir. red. ir. cp (inc_segment H5).
  assert (inc y x). uf x.  order_tac. cp (H4 _ H7). awii H8. order_tac.
Qed.

Lemma Exercise2_6g: forall r a, worder r -> inc a (substrate r) ->
  let m := Zo (substrate r) (fun z => glt r a z) in
    nonempty m -> exists b, 
      inc b (substrate r) & (segment_c r a = segment r b).
Proof. ir. cp (worder_total H). nin H2. clear H2. rename H3 into Ht.
 nin H. assert (sub m (substrate r)). uf m. app Z_sub.
  nin (H2 _ H3 H1). nin H4. awii H4. awii H5. exists  x. split. app H3.
  set_extens. rww segment_rw.  rwii segmentc_rw H6. ufi m H4. Ztac. order_tac.
  app H3. rww segmentc_rw.  rwii segment_rw H6. ufi m H4. Ztac. 
  assert (inc x0 (substrate r)). order_tac. nin (Ht _ _ H9 H0). am.
  nin (equal_or_not x0 a). rw H11; rwi H11 H10; am. assert (glt r a x0). 
  split. am. au. assert (inc x0 m). uf m. clear H4. Ztac.  cp (H5 _ H13).
  awi H14. order_tac. am. am. app H3.
Qed.

Lemma Exercise2_6h: forall r f a, Ex2_6H r f ->
  inc a (source f) -> worder (induced_order r  (Ex2_6chain r f a)).
Proof. ir. set (E:= substrate r).
  set(M0 :=  Zo (powerset E) (fun z => inc a z & exists b,
    least_upper_bound r z b)).
  assert (forall z, inc z M0 -> least_upper_bound r z (supremum r z)).
  ir. ufi M0 H1. Ztac. nin H3. nin H4. rwi powerset_inc_rw H2. nin H.
  app supremum_pr1. exists x. am.
  assert (forall x, inc x M0 -> (inc  (supremum r x) (substrate r)
    & inc (W (supremum r x) f) (substrate r))).
  ir. cp (H1 _ H2). red in H. nin H. ufi M0 H2. Ztac.  rwi powerset_inc_rw H5.
  awii H3. nin H3. nin H3. ee. am. rw H11. app inc_W_target. ue.
  set (sif := fun x => glt r x (W x f)).
  set (M1 := Zo M0 (fun z => ~ (inc (supremum r z) z))).
  set (M2 := Zo M0 (fun z => sif (supremum r z))).
  set(M:= tack_on (union2 M1 M2) emptyset). 
  set (p:= fun x => Yo (x= emptyset) a 
    (Yo (inc x M1)  (supremum r x) (W (supremum r x) f))).
  assert (Ha:sub (union2 M1 M2) M0). uf M1; uf M2. red. ir.
  nin (union2_or H3); Ztac;am.
  assert (forall x, inc x M -> ~ (inc (p x) x)). ir. red. ir. ufi p H4.
  nin (equal_or_not x emptyset). rwi Y_if_rw H4. rwi H5 H4.
  elim (emptyset_pr H4). am. rwii Y_if_not_rw H4. ufi M H3.
  rwi tack_on_inc H3. nin H3. nin (inc_or_not x M1). rwii Y_if_rw H4. 
  ufi M1 H6. Ztac. contradiction. nin (union2_or H3). contradiction.  
  rwii Y_if_not_rw H4. ufi M2 H7. Ztac. red in H9. cp (H1 _ H8).
  awii H10. nin H10. nin H10. cp (H12 _ H4). nin H. order_tac. nin H;am.
  ufi M0 H8. Ztac. app powerset_sub. contradiction.
  assert (forall x, inc x M -> inc (p x) E). ir. red in H. ee. uf p.
  nin (equal_or_not x emptyset). rww Y_if_rw.  uf E. ue. rww Y_if_not_rw. 
  ufi M H4. rwi tack_on_inc H4. nin H4. nin (H2 _  (Ha _ H4)).
  nin (inc_or_not x M1). rww Y_if_rw. rww Y_if_not_rw. contradiction.
  assert (sub M (powerset E)). red. ir. ufi M H5. rwi tack_on_inc H5.
  nin H5. ufi M1 H5; ufi M2 H5; ufi M0 H5. nin (union2_or H5); Ztac. 
  Ztac. am. Ztac. am. rw H5. app powerset_inc. app sub_emptyset_any.
  assert (forall x, inc x M -> (inc (p x) E & ~ (inc (p x) x))). 
  ir. split. app H4. app H3.

  nin (Zermelo_aux _ H5 H6). nin H7. red in H7. ee.
  set (q:= substrate x) in *. assert (inc a q). nin (emptyset_dichot q).
  elim H8. uf M. rw H12. fprops. nin (Exercise2_6f H7 H12). nin H13.
  cp (H11 _ H13). rwi H14 H15. ufi p H15. rwii Y_if_rw H15. rww H15.
  assert (forall a b, gle x a b -> gle r a b). ir.
  assert (inc b q). uf q. nin H. order_tac. assert (inc b E). app H9.
  nin (equal_or_not a0 b). rw H16. nin H. order_tac.
  assert (inc a0 (segment x b)). app segment_inc. split; am.
  cp (H11 _ H14). cp (H10 _ H14). ufi M H19. rwi tack_on_inc H19. nin H19.
  cp  (H1 _ (Ha _ H19)). nin H; ee.
  assert (gle r a0 (supremum r (segment x b))). awii H20. nin H20. nin H20.
  app H26.  apply sub_trans with q.  uf q. app sub_segment. am.
  ufi p H18. rwi Y_if_not_rw H18. nin (inc_or_not (segment x b) M1).
  rwii Y_if_rw H18. wrr H18. rwii Y_if_not_rw H18.
  set (c:=supremum r (segment x b)) in *. assert (inc c (substrate r)). 
  order_tac. cp (H24 _ H27). wr H18. order_tac. red. ir. rwi H26 H17.
  elim (emptyset_pr H17). rwi H19 H17. elim (emptyset_pr H17).
  assert (forall x, inc x q -> inc (W x f) q). ir.
  set (m:=Zo q (fun z => glt x x0 z)). nin (emptyset_dichot m).
  assert (greatest_element x x0). split. am. ir.
  cp (worder_total H7). nin H17. nin (H18 _ _ H14 H16). 
  nin (equal_or_not x0 x1). rw H20; rwi H20 H19; am. 
  elim (emptyset_pr (x:=x1)). wr H15. uf m. Ztac. split;am. am. 
  nin H. ee. assert (greatest_element (induced_order r q) x0). split. aw.
  aw. ir. aw. app H13. nin H16. app H22. cp (greatest_is_sup H H9 H21).
  ufi M H8. nin (inc_or_not (W x0 f) q). am. elim H8.
  assert (inc q M0). uf M0. Ztac. app powerset_inc. ee. am. exists x0. am.
  app inc_tack_on_y. app union2_second. uf M2. Ztac. uf sif. 
  wr (supremum_pr2 H H9 H22). split. app H20. ue. ue. dneg. wrr H25.
  nin (Exercise2_6g H7 H14 H15). nin H16.
  cp (H10 _ H16). cp (H11 _ H16). ufi M H18. rwi tack_on_inc H18. nin H18.
  cp (H1 _ (Ha _ H18)). 
  nin H; nin H7. assert (sub (segment_c x x0) (substrate r)). 
  apply sub_trans with q. uf q. app sub_segmentc. am. 
  assert (greatest_element (induced_order r (segment_c x x0)) x0). split.
  aw. app inc_bound_segmentc. aw. ir. aw. rwi segmentc_rw H24.
  app H13. am. app  inc_bound_segmentc.
  cp (greatest_is_sup H H23 H24). rwi H17 H25. cp (supremum_unique H H20 H25).
  ufi p H19. rwi Y_if_not_rw H19. nin (inc_or_not (segment x x1) M1).
  rwii Y_if_rw H19. ufi M1 H27. Ztac. rwi H26 H29. elim H29. wr H17. 
  app inc_bound_segmentc.  rwii Y_if_not_rw H19.  nin (union2_or H18).
  contradiction. ufi M2 H28. Ztac. rwi H26 H19. rw H19. am.
  red. ir. elim (emptyset_pr (x:=x0)). wr H27. wr H17. app inc_bound_segmentc.
  elim (emptyset_pr (x:=x0)). wr H18. wr H17. app inc_bound_segmentc. nin H7;am.

  assert (forall N y, sub N q -> nonempty N -> least_upper_bound r N y ->
     inc y q).
  nin (worder_total H7). clear H15. rename H16 into Ht.
  assert (forall a b, inc a q -> inc b q -> gle r a b \/ glt r b a).
  ir. nin H. nin (equal_or_not a0 b). rw H18. left.
  order_tac. app H9. nin (Ht _ _ H15 H16). left. app H13. right. split.
  app H13. au.
  ir. red in H; nin H7. ee. cp (sub_trans H16 H9). awii H18. nin H18.
  set (bN:=Zo q (fun z=> gle r y z)).
  nin (emptyset_dichot bN). 
  assert (least_upper_bound r q y). aw. split. split. nin H18; am. 
  ir. nin H18. assert (exists t, inc t N & glt r y0 t). app exists_proof.
  red. ir. elim (emptyset_pr (x:=y0)). wr H26. uf bN. Ztac. app H25.
  split. app H9. ir. nin (H15 _ _ (H16 _ H30) H27). am. elim (H29 y1). au. 
  nin H29. nin H29. nin H30. cp (H28 _ H29). order_tac. ir. app H25.
  split. nin H27;am. ir. nin H27. app H29. app H16. nin (inc_or_not y q). am.
  elim H8. uf M. app inc_tack_on_y. app union2_first. uf M1. Ztac. uf M0.
  Ztac. app powerset_inc. ee. am. exists y. am. wrr (supremum_pr2 H H9 H27).
  assert (sub bN q). uf bN. app Z_sub. nin (H19 _ H27 H26). nin H28.
  awii H28. awii H29. ufi bN H28. Ztac. clear H28.
  assert (forall u, inc u q -> gle r y u -> gle x x0 u). ir.
  assert (inc u bN). uf bN. Ztac. cp (H29 _ H33). 
  ap (related_induced_order1 H34). nin (inc_or_not y q). am.
  nin (inc_or_not x0 N). nin H18. cp (H34 _ H33).
  assert (x0 = y). order_tac. wrr H36.
  assert (sub N (segment x x0)). red. ir. rww segment_rw. split. nin H18.
  cp (H35 _ H34). assert (gle r x1 x0). order_tac.
  nin (Ht _ _ (H16 _ H34) H30). am. cp (H13 _ _ H38).
  assert (x0 = x1). order_tac. rw H40; rwi H40 H38; am. dneg. ue.
  assert (nonempty (segment x x0)). nin H17. exists y0. app H34.
  cp (H10 _ H30). cp (H11 _ H30). ufi M H36.
  assert (inc (segment x x0) (union2 M1 M2)). rwi tack_on_inc H36. nin H36. 
  am.  rwi H36 H35. nin H35. elim (emptyset_pr H35). clear H36.
  ufi p H37. nin (equal_or_not  (segment x x0) emptyset).
  rwi H36 H35. nin H35. elim (emptyset_pr H35). rwii Y_if_not_rw H37. 
  clear H36. 
  cp (Ha _ H38). ufi M0 H36. Ztac. clear H36. rwi powerset_inc_rw H39. 
  clear H40.  cp (H1 _ (Ha _ H38)).
  set (s:= supremum r (segment x x0)) in *.
  assert (gle r y s). awii H36. ee. app H25. nin H36. split. am. ir. 
  nin H18. cp (H43 _ H42). app H41. app H34. 
  assert (gle r s x0). awii H36.  nin H36. app H41. split. order_tac. ir. 
  nin (inc_segment H42). app H13. 
  assert (~ (inc s (segment x x0))). red. ir. rwi segment_rw H42.
  assert (inc s q). uf q. order_tac. cp (H28 _ H43 H40). order_tac. am.
  assert (inc (segment x x0) M1). uf M1. Ztac. rwi Y_if_rw H37. 
  assert (gle r s y). awii H36. nin H36. app H44. split. order_tac. ir.
  rwi segment_rw H45. assert (inc y0 q). uf q. order_tac.
  nin (p_or_not_p (exists u, inc u N & glt r y0 u)). nin H47. nin H47.
  nin H18. cp (H49 _ H47). nin H48. order_tac.
  assert (forall u, inc u N -> gle r u y0). ir. cp (H15 _ _ (H16 _ H48) H46). 
  nin H49. am. elim H47. exists u. au.
  assert (upper_bound r N y0). split. app H9. am. cp (H25 _ H49).  
  cp (H28 _ H46 H50). order_tac. am. assert (y =s). order_tac. rw H45; rw H37.
  am. am.
  assert (sub (Ex2_6chain r f a) q). uf Ex2_6chain. red. ir.
  apply (intersection_forall (y:=q) H16). Ztac. uf Ex2_6S. Ztac.
  app powerset_inc. cp (sub_trans H16 H9). split. ufi E H17. nin H. fprops.
  nin H. aw. ir.  cp (sub_trans H19 H16). cp (sub_trans H21 H9).
  nin H7. nin (H23 _ H21 H20). nin H24. awii H24. awii H25. exists x1. 
  wrr induced_trans. split. aw. aw. ir. cp (H25 _ H26). awii H27. aw. app H13.
Qed.


Lemma Exercise2_6i: forall r f, Ex2_6H r f -> inductive_set r ->
  exists a, inc a (source f) & W a f = a.
Proof. ir.  nin H. nin (Zorn_lemma H H0). nin H2. ee.
  cp (H6 _ H2). cp (H3 _ H7). exists x. wr H4. au.
Qed.


(* Exercise 7 *)
Definition set_of_closures r :=
  let E:=substrate r in
  Zo (set_of_functions E E) (fun z=> is_closure (sof_value E E z) r).

Definition closure_ordering r :=
  let E:=substrate r in
    induced_order (function_order E E r) (set_of_closures r).

Lemma Exercise2_7a: forall r f g, order r ->
  let E:=substrate r in
  gle (closure_ordering r) f g =
  (inc f (set_of_closures r) & inc g (set_of_closures r) &
    forall i, inc i (substrate r) -> 
      gle r (W i (sof_value E E f)) (W i (sof_value E E g))).
Proof. ir. assert (sub (set_of_closures r) (substrate (function_order E E r))).
  rw substrate_function_order. uf set_of_closures. app Z_sub. am. tv.
  assert (order (function_order E E r)). app order_function_order. 
  uf closure_ordering. app iff_eq. ir. 
  cp (related_induced_order1 H2). cp (related_induced_order3 H2). eee.
  rwi function_order_pr H3. eee. am. tv. ir. ee. aw.
  ufi set_of_closures H2. Ztac. ufi set_of_closures H3. Ztac.
  rww function_order_pr. eee.
Qed.

Lemma Exercise2_7b: forall r, order r ->
  (order (closure_ordering r) & 
  substrate (closure_ordering r) = (set_of_closures r)).
Proof. ir. uf closure_ordering. cp (refl_equal (substrate r)).
  cp (order_function_order (substrate r) H H0).
  cp (substrate_function_order (substrate r) H H0).
  assert (sub (set_of_closures r)
   (substrate (function_order (substrate r) (substrate r) r))). rw H2.
  uf set_of_closures. app Z_sub. split.  app order_induced_order. aw.
Qed.

Lemma Exercise2_7c: forall r, order r ->
  least_element (closure_ordering r) (corr_value (identity_fun (substrate r))).
Proof. ir. set (E:=substrate r). set (f:= identity_fun E).
  assert (f = sof_value (substrate r) (substrate r) (corr_value f)).
  uf corr_value. uf sof_value. aw.
  assert (inc (corr_value f) (set_of_closures r)). uf set_of_closures.
  Ztac. app inc_set_of_functionsc. uf f. app function_identity.
  wr H0. red. uf f. ee. red; eee.
  app function_identity. red. simpl. ir. rww W_identity. rww W_identity.
  uf E. order_tac. uf E. order_tac.
  ir. rww W_identity. order_tac. ir. repeat  rww W_identity.
  nin (Exercise2_7b H). split. ue. rw H3. ir. rw Exercise2_7a. eee. ir.
  wr H0. uf f. rww W_identity. ufi set_of_closures H4. Ztac.
  set (g:= sof_value (substrate r) (substrate r) x) in *.
  red in H7. ee. app H8. am.
Qed.

Lemma Exercise2_7d: forall r f g, order r ->
  let E:=substrate r in
    gle (closure_ordering r) f g ->
    sub (set_of_invariants (sof_value E E g))
    (set_of_invariants (sof_value E E f)).
Proof. ir. rwii Exercise2_7a H0. ee. ufi set_of_closures H0.
  ufi set_of_closures H1. Ztac. clear H1. Ztac. red in H4; red in H5. ee.
  uf set_of_invariants. red. uf E. ir. Ztac. app Z_inc.
  red in H4. red in H5. ee. wri H20 H11. cp (H6 _ H11).
  cp (H2 _ H11). rwi H12 H24. order_tac. 
Qed.

Lemma Exercise2_7e: forall r f g, order r ->
  (forall x y, inc x (substrate r) -> inc y (substrate r) ->
    has_infimum r (doubleton x y))
  -> inc f (set_of_closures r)
  -> inc g (set_of_closures r)
  -> has_infimum (closure_ordering r) (doubleton f g).
Proof. ir.
  assert (Ht:sub (doubleton f g) (set_of_closures r)). red. ir.
  nin (doubleton_or H3); rww H4.
  ufi set_of_closures H1. Ztac. clear H1.
  ufi set_of_closures H2. Ztac. clear H2.
  set (f1:= sof_value (substrate r) (substrate r) f) in *.
  set (g1:= sof_value (substrate r) (substrate r) g) in *. red in H4.
  red in H5. ee. set (E:= substrate r) in *.
  assert (Ha: forall x, inc x E -> inc (W x f1) E). ir. cp (H7 _ H9).
  uf E. order_tac.
  assert (Hb: forall x, inc x E -> inc (W x g1) E). ir. cp (H5 _ H9).
  uf E. order_tac.
  set (hh:= fun z=> inf r (W z f1) (W z g1)).
  assert (forall x, inc x E -> 
    (gle r (hh x) (W x f1)  &  gle r (hh x) (W x g1) &
      forall z, gle r z (W x f1) ->  gle r z (W x g1) -> gle r z (hh x))).
  ir. cp (Ha _ H9). cp (Hb _ H9). cp (inf_pr H H10 H11 (H0 _ _ H10 H11)). eee. 
  assert (transf_axioms hh E E). red. ir. nin (H9 _ H10). uf E. order_tac.
  assert (Hg: forall x, inc x E -> gle r x (hh x)). ir. nin (H9 _ H11). ee.
  app H14. app H7. app H5.
  assert (forall x y, gle r x y -> gle r (hh x) (hh y)).
  ir. nin H4. nin H2. ee. cp (H21 _ _ H11). cp (H17 _ _ H11).
  assert (inc x E). uf E. order_tac.  assert (inc y E). uf E. order_tac.
  cp (H9 _ H24). cp (H9 _ H25). ee. ap H29. order_tac. order_tac.
  set (h:= BL hh E E).  assert (is_function h). uf h. app af_function.
  assert (is_closure h r). red. ee. red. eee. ir. uf h. aw. app H11.
  uf E; order_tac. uf E; order_tac.
  ir. uf h. aw. app Hg. ir. uf h. set (t:= hh x).
  assert (inc t E). uf t. app H10. assert (W x (BL hh E E) = t). aw.
  rw H15. assert (W t (BL hh E E) = hh t). ap W_af_function. am. am. 
  rw H16. clear H16. clear H15. cp (Hg _ H14). assert (gle r (hh t) t).
  cp (H9 _ H14). ee.  cp (H9 _ H13). ee. red in H4. ee.
  cp (H26 _ _ H19). red in H2. ee. cp (H32 _ _ H20). rwi (H8 _ H13) H27.
  rwi (H6 _ H13) H33. fold t in H27.  fold t in H33. ap H21.
  order_tac. order_tac. order_tac.
  assert (sof_value (substrate r) (substrate r) (corr_value h) = h).
  uf sof_value. uf corr_value. aw. 
  nin (Exercise2_7b H).
  assert (inc (corr_value h) (substrate (closure_ordering r))). rw H16.
  uf set_of_closures. Ztac. app inc_set_of_functionsc. ue.  
  exists (corr_value h). aw. ee. split. am. ir. rw  Exercise2_7a. ee. ue.
  app Ht.  ir. rw H14. uf h. aw.  cp (H9 _ H19). ee.
  nin (doubleton_or H18); rw H23. exact  H20.  exact  H21. am.
  ir. nin H18. assert (inc f (doubleton f g)). fprops. cp (H19 _ H20).
  assert (inc g (doubleton f g)). fprops. cp (H19 _ H22).
  rwi  Exercise2_7a H21.  rwi  Exercise2_7a H23. ee. rww  Exercise2_7a.
  ee. am. ue. ir. cp (H27 _ H28). cp (H25 _ H28). rw H14. uf h. aw.
  cp (H9 _ H28). ee.  app H33. am. am. ue.
Qed.

Lemma Exercise2_7f: forall r, complete_lattice r ->
  complete_lattice (closure_ordering r).
Proof. ir. red in H. ee. nin (Exercise2_7b H).
  app exercise1_11h. ir. rwi H2 H3.
  set (ic:= fun f => sof_value (substrate r) (substrate r) f).
  assert (forall f, inc f X -> is_closure (ic f) r). ir. cp (H3 _ H4).
  ufi set_of_closures H5. Ztac. uf ic. aw.
  set (iv := fun x => fun_image X (fun z => W x (ic z))).
  assert (forall x, inc x (substrate r) -> sub (iv x) (substrate r)).
  ir. red. ir. ufi iv H6. awi H6. nin H6. nin H6. cp (H4 _ H6). wr H7.
  red in H8. ee. nin H8. ee. rw H14. app inc_W_target.
  set (hh := fun x => infimum r (iv x)).
  assert (forall x, inc x (substrate r) -> (lower_bound r (iv x) (hh x) & 
    forall z, lower_bound r (iv x) z -> gle r z (hh x))).
  ir. cp (H5 _ H6). nin (H0 _ H7). uf hh. ap (infimum_pr H H7 H9).
  assert (transf_axioms hh (substrate r) (substrate r)). red. ir.
  nin (H6 _ H7). nin H8. am.
  set (h:= BL hh (substrate r) (substrate r)).
  assert (is_function h). uf h. app af_function.
  assert (forall x f, inc x (substrate r) -> inc f X ->
    gle r (W x h) (W x (ic f))). ir.
  nin (H6 _ H9). nin H11. uf h. aw. app H13. uf iv. aw. exists f. au.
  assert (forall x y, inc x (substrate r) ->  inc y (substrate r) ->
    (forall f, inc f X -> gle r y  (W x (ic f))) -> gle r y (W x h)).
  ir. nin (H6 _ H10). uf h. aw. app H14. split. am. ir. ufi iv H15.
  awi H15. nin H15. nin H15. wr H16. app H12.
  assert (increasing_fun h r r). red. eee. ir.
  assert (inc x (substrate r)). order_tac.
  assert (inc y (substrate r)). order_tac. app H10. 
  uf h. aw. app H7. ir. cp (H9 _ _ H12 H14). cp (H4 _ H14). red in H16. 
  ee. red in H16. ee. cp (H23 _ _ H11). order_tac.
  assert (forall x, inc x (substrate r) -> gle r x (W x h)).
  ir. app (H10 _ _ H12 H12). ir. nin (H4 _ H13).  ee. app H15.
  assert (forall x, inc x (substrate r) -> W (W x h) h = W x h). ir.
  set (t := W x h) in *. assert (inc t (substrate r)).
  change (inc  (W x h) (target h)). app inc_W_target. 
  assert (gle r t (W t h)). app H12. 
  assert (gle r (W t h) t). uf t. app H10.
  change (inc (W (W x h) h) (target h)). app inc_W_target. ir.
  cp (H9 _ _ H13 H16).  cp (H9 _ _ H14 H16). fold t. fold t in H17.
  nin (H4 _ H16). ee. red in H19. ee. cp (H26 _ _ H17). 
  rwi (H21 _ H13) H27. order_tac. order_tac.
  assert (is_closure h r). red. eee.
  assert (sof_value (substrate r) (substrate r) (corr_value h) = h).
  uf sof_value. uf corr_value. aw. 
  assert (inc (corr_value h) (substrate (closure_ordering r))). rw H2.
  uf set_of_closures. Ztac. app inc_set_of_functionsc. ue.  
  exists (corr_value h). aw. ee. split. am. ir. rw Exercise2_7a. ee. ue.
  app H3. ir. rw H15. app H9. am. ir. nin H17. rwi H2 H17.
  rww  Exercise2_7a. ee. am. ue. ir. rw H15.
  set (k:= W i (sof_value (substrate r) (substrate r) z)).
  assert (inc k (substrate r)). ufi set_of_closures H17. Ztac.
  red in H21. ee. red in H21. ee. rw H27. uf k. app inc_W_target.
  app H10. ir.  cp (H18 _ H21). rwi  Exercise2_7a H22. ee. cp (H24 _ H19).
  fold k in H25. am. am. ue.
Qed.

Lemma Exercise2_7g: forall r u v, 
  let fp := fun x f => Zo (substrate r) (fun z => gle r x z & W z f = z) in
    let f := compose (sof_value (substrate r) (substrate r) u)
      (sof_value (substrate r) (substrate r) v) 
      in  order r -> inc u (set_of_closures r) -> inc v (set_of_closures r)
      -> (forall x, inc x (substrate r) -> exists y, 
        least_element (induced_order r (fp x f)) y)
      -> has_supremum (closure_ordering r) (doubleton u v).
Proof. ir. 
  assert (Ht:sub (doubleton u v) (set_of_closures r)). red. ir.
  nin (doubleton_or H3); rww H4.
  ufi set_of_closures H0. Ztac. clear H0.
  ufi set_of_closures H1. Ztac. clear H1.
  set (u1:= sof_value (substrate r) (substrate r) u) in *.
  set (v1:= sof_value (substrate r) (substrate r) v) in *. red in H4.
  red in H5. ee. set (E:= substrate r) in *.
  assert (Ha: forall x, inc x E -> inc (W x u1) E). ir. cp (H7 _ H9).
  uf E. order_tac.
  assert (Hb: forall x, inc x E -> inc (W x v1) E). ir. cp (H5 _ H9).
  uf E. order_tac.
  assert (composable u1 v1). red. red in H4; red in H1; ee. am. am. ue.
  assert (is_function f). uf f. fct_tac.
  set (gg := fun x => the_least_element (induced_order r (fp x f))).
  assert (forall x, inc x E -> sub (fp x f) (substrate r)). 
  ir. uf fp. app Z_sub. 
  assert (forall x, inc x E -> substrate (induced_order r (fp x f))
    = (fp x f)). ir. aw. app H11.
  assert (forall x, inc x E -> least_element (induced_order r (fp x f)) (gg x)).
  ir. cp (H2 _ H13). set (F:= induced_order r (fp x f)) in *.
  assert (order F). uf F. fprops. ap (the_least_element_pr H15 H14). 
  assert (transf_axioms gg E E). red. ir. nin (H13 _ H14). rwi H12 H15.
  app (H11 _ H14). am.
  assert (forall x, inc x E -> gle r x (gg x)). ir.
  nin (H13 _ H15). rwi H12 H16. ufi fp H16. Ztac. ee. am. am.
  assert (forall x, inc x E -> gg (gg x) = gg x). ir.
  nin (H13 _ H16). rwi H12 H17. ufi fp H17. Ztac. ee. 
  nin (H13 _ H19). rwi H12 H23. rwi H12 H22. ufi fp H22. Ztac. ee. 
  assert (inc (gg x) (fp (gg x) f)).  uf fp. app Z_inc. eee. order_tac.
  cp (H23 _ H27). cp (related_induced_order1 H28). order_tac. am. am. am.
  assert (forall x y, gle r x y -> gle r (gg x) (gg y)).
  ir. assert (inc x E). uf E. order_tac. assert (inc y E). uf E. order_tac.
  cp (H15 _ H19). cp (H13 _ H18). nin H21. rwi  H12 H22.
  assert (inc (gg y) (fp x f)). uf fp. Ztac. split. order_tac.
  cp (H13 _ H19).  nin H23. rwi (H12 _ H19) H23.  ufi fp H23.  Ztac. ee; am.
  cp (H22 _ H23). ap (related_induced_order1 H24). am.
  set (g:= BL gg E E). assert (is_function g). uf g. app af_function.
  assert (is_closure g r). split. red. eee. ir.  uf g.  aw. app H17. 
  uf E. order_tac. uf E. order_tac. ee. ir. uf g. aw. app H15. ir.
  uf g. aw. app H16. aw. app H14.
  assert (sof_value (substrate r) (substrate r) (corr_value g) = g).
  uf sof_value. uf corr_value. aw. 
  nin (Exercise2_7b H).
  assert (inc (corr_value g) (set_of_closures r)). uf set_of_closures.
  Ztac. app inc_set_of_functionsc. ue. exists (corr_value g).
  aw. ee. split. rww H22. ir. rw  Exercise2_7a. ee. app Ht. am.
  ir. rw H20. uf g. aw. set (a := gg i). cp (H15 _ H25). fold a in H26.
  assert (gle r (W i v1) (W a v1)). red in H1. ee. app H31.
  assert (gle r (W (W i v1) u1) (W (W a v1) u1)). red in H4. ee. app H32.
  assert ((W (W a v1) u1) = a).  cp (H13 _ H25). nin H29. rwi H12 H29. 
  ufi fp H29. Ztac. nin H32. fold a in H33. ufi f H33. awi H33. am. am.
  am. am. rwi H29 H28. assert (inc (W i v1) E). uf E; order_tac.
  cp (H7 _ H30).  assert (gle r (W i v1) a). order_tac.
  cp (H5 _ H25). assert (gle r i (W a v1)). order_tac.
  assert (gle r (W i u1) (W (W a v1) u1)). red in H4. ee. app H39.
  rwi H29 H35. nin (doubleton_or H24); rw H36. am. am. am.
  ir. nin H24. rw Exercise2_7a. ee. am. ue. ir. rw H20.
  assert (inc u (doubleton u v)). fprops. cp (H25 _ H27).
  assert (inc v (doubleton u v)). fprops. cp (H25 _ H29).
  rwi  Exercise2_7a H28. rwi  Exercise2_7a H30. ee. uf g. aw.
  set (z1:= sof_value (substrate r) (substrate r) z) in *.
  set (j := W i z1). assert (inc j E). uf E. cp (H34 _ H26). order_tac.
  ufi set_of_closures H31. Ztac. clear H31. fold z1 in H37. red in H37. ee.
  fold E in H34. fold u1 in  H34.  fold E in H32. fold v1 in H32.
  cp (H7 _ H35). cp (H5 _ H35). cp (H34 _ H35). cp (H32 _ H35).
  cp (H38 _ H26). fold j in H43. rwi H43 H41; rwi H43 H42.
  assert (j = W j u1). order_tac.  assert (j = W j v1). order_tac. 
  assert (j = W j f). uf f. aw. wr H45; wrr H44.
  cp (H13 _  H26). nin H47.  rwi (H12 _ H26) H48.
  assert (inc j (fp i f)). uf fp. Ztac. ee. ap (H37 _ H26). sy; am.
  cp (H48 _ H49). ap (related_induced_order1 H50). am. am. am. ue.
Qed.  

Lemma Exercice2_7A1: forall r, 
  (exists u, greatest_element r u) -> inductive_set r.
Proof. ir. red. ir. nin H. exists x. nin H. split. am. ir. app H2. app H0.
Qed.

Lemma Exercice2_7A2: forall r r', order r  -> order r' ->
  (exists u, greatest_element r' u) 
  -> inductive_set  (ordinal_sum2 r r').
Proof. ir. app Exercice2_7A1. nin H1. exists (J x TPb). 
  assert (inc (J x TPb) (canonical_du2 (substrate r) (substrate r'))).
  rw canonical_du2_pr.  aw. split. fprops. right. split. nin H1. am. tv. 
  split. rww substrate_ordinal_sum2. ir. rwii substrate_ordinal_sum2 H3.
  rww related_ordinal_sum2_order. ee. am. am.
  rwi canonical_du2_pr H3. ee. nin H4. right. right. aw. ee. am. fprops.
  right. left. aw. nin H4. rw H5. ee. fprops. fprops. nin H1. app H6.
Qed.

Definition NNstar := 
  ordinal_sum2 Bnat_order (opposite_order Bnat_order).

Lemma Exercice2_7A3: 
  order NNstar & substrate NNstar =  canonical_du2 Bnat Bnat
  & (forall x x', gle NNstar x x' = 
    (inc x (canonical_du2 Bnat Bnat) &
    inc x' (canonical_du2 Bnat Bnat) &
    ((Q x = TPa & Q x' = TPa & cardinal_le (P x) (P x'))
      \/ (Q x <> TPa & Q x' <> TPa & cardinal_le (P x') (P x))
      \/ (Q x = TPa & Q x' <> TPa)))).
Proof. ir. uf NNstar. 
  cp substrate_Bnat_order. nin worder_Bnat_order. clear H1.
  cp (opposite_is_order H0).  cp (substrate_opposite_order H0).  rwi H H2.
  ee. app order_ordinal_sum2. rww substrate_ordinal_sum2. rw H. rww H2.
  ir. rww related_ordinal_sum2_order. rw H; rw H2. rww opposite_gle.
  rw related_Bnat_order. rw related_Bnat_order. uf Bnat_le.
  app iff_eq; ir; eee. nin H5.  left. ee; am. nin H5. right; left; ee; am.
  right;  right; ee; am.
  assert (inc (P x) Bnat). rwi canonical_du2_pr H3. nin H3. nin H6;ee; am.
  assert (inc (P x') Bnat). rwi canonical_du2_pr H4. nin H4. nin H7;ee; am.
  nin H5. left. eee. nin H5. right; left; eee. right; right; eee.
Qed.

Lemma Exercice2_7A4: inductive_set NNstar.
Proof. uf NNstar. nin (worder_Bnat_order). app  Exercice2_7A2. 
  app opposite_is_order. exists card_zero. app least_reverse.
  cp substrate_Bnat_order.  split. rw H1. fprops. ir.
  rw related_Bnat_order.  red. rwi H1 H2. eee.
Qed.

Definition extension_to_NNstar f :=
  BL (fun z=> Yo (Q z = TPa) (J (W (P z) f) TPa) z) 
  (substrate NNstar) (substrate NNstar).

Lemma Exercice2_7A5: forall f, function_prop f Bnat Bnat ->
  ((forall x, inc x Bnat -> 
    W (J x TPa) (extension_to_NNstar f) = (J (W x f) TPa)) &
  (forall x, inc x (substrate NNstar) -> Q x = TPb ->
    W x (extension_to_NNstar f) = x) &
  function_prop (extension_to_NNstar f) (substrate NNstar) (substrate NNstar)).
Proof. ir. red in H. destruct Exercice2_7A3 as [_ [H1 _]]. rw H1.
  assert (transf_axioms (fun z=> Yo (Q z = TPa) (J (W (P z) f) TPa) z)
    (substrate NNstar) (substrate NNstar)). rw H1. red. ir.
  cp H0. rwi canonical_du2_pr H0. nin H0. nin H3; nin H3. rw Y_if_rw. 
  rw canonical_du2_pr.  aw. split. fprops. left. split. ee. wr H6. 
  app inc_W_target. ue. tv. am. rw Y_if_not_rw. am. rw H4. fprops.
  ee. ir. uf extension_to_NNstar. aw. rww Y_if_rw. rww H1. 
  rww canonical_du2_pr. aw. split. fprops. au.  
  ir. uf extension_to_NNstar. aw. rw H5. rww Y_if_not_rw. fprops. ue.
  red. eee. uf extension_to_NNstar. app af_function.
Qed.

Lemma Exercice2_7A6: forall f, is_closure f Bnat_order ->
  is_closure  (extension_to_NNstar f) NNstar.
Proof. ir. red in H. ee.  red in H. cp substrate_Bnat_order. ee.
  assert (function_prop f Bnat Bnat). red. eee.
  cp (Exercice2_7A5 H8). ee. red in H11. ee. cp Exercice2_7A3. ee.
  red. ee. red. eee. ir. rwi H16 H17. ee. rw H16. ee. wr H15.
  wr H13. app inc_W_target. rww H12. ue. wr H15. wr H13. app inc_W_target. 
  rww H12. ue. nin H19. left. rwi canonical_du2_pr H17. nin H17. nin H20.
  nin H20. assert (x = J (P x) (Q x)). aw. rw H22. rw H21. rw (H9 _ H20).
  rwi canonical_du2_pr H18. nin H18. nin H23. nin H23. 
  assert (y = J (P y) (Q y)). aw. rw H25. rw H24. rw (H9 _ H23). aw. ee.
  tv. tv. assert (gle Bnat_order (P x) (P y)). rw related_Bnat_order.
  red. eee. cp (H7 _ _ H28).  rwi related_Bnat_order H29. red in H29. ee; am.
  nin H23. nin H19. nin H25. rwi H25 H24. assert (TPa <> TPb). fprops.
  contradiction.  nin H20. nin H19. rwi H19 H21. assert (TPa <> TPb). fprops.
  contradiction. nin H19. right. left. 
  assert (W x (extension_to_NNstar f) = x). app H10. ue.
  rwi  canonical_du2_pr H17.  nin H17. nin H20. ee. contradiction. ee; am.
  assert (W y (extension_to_NNstar f) = y). app H10. ue.
  rwi  canonical_du2_pr H18. nin H18. nin H21. ee. contradiction. ee; am.
  rw H20. rw H21. am. right. right.
  assert (W y (extension_to_NNstar f) = y). app H10. ue.
  rwi  canonical_du2_pr H18. nin H18. nin H20. ee. contradiction. ee; am.
  rw H20. rwi canonical_du2_pr H17. nin H17. nin H21.
  nin H21. assert (x = J (P x) (Q x)). aw. rw H23. rw H22. rw (H9 _ H21). aw.
  eee.  assert (TPa <> TPb). fprops. nin H21. nin H19. rwi H19 H23. 
  contradiction.
  ir. assert (Ht:= H17). rw H16. ee. ue. wr H15. wr H13. app inc_W_target.
  rwi H15 H17.  rwi canonical_du2_pr H17. ee. nin H18. nin H18. 
  assert (x = J (P x) (Q x)). aw. left. split. am. rw H20. rw H19. 
  rw (H9 _ H18). aw. split. tv. 
  assert (inc (P x) (substrate Bnat_order)). ue.  cp (H0 _ H21). 
  rwi related_Bnat_order H22. red in H22. ee. am. right. left.
  assert (W x (extension_to_NNstar f) = x). app H10. nin H18;am. rw H19.
  nin H18. rw H20. ee. fprops. fprops. fprops.
  ir.  cp H17. rwi H15 H18. rwi  canonical_du2_pr H18. nin H18. nin H19. 
  nin H19.  assert (x = J (P x) (Q x)). aw. rw H21. rw H20. 
  rw (H9 _ H19). assert (inc (W (P x) f) Bnat). red in H8. ee. wr H23.
  app inc_W_target. rww H22. rw (H9 _  H22). rww H1. ue.
  assert (W x (extension_to_NNstar f) = x). app H10. nin H19;am. rw H20. am.
Qed.

Definition even_int n := inc n Bnat & card_rem n card_two = card_zero.
Definition odd_int n := inc n Bnat & ~ (even_int n).

Lemma even_odd_aux: forall n m, 
  inc n Bnat -> inc m Bnat ->
  succ (card_mult n card_two) <> (card_mult m card_two).
Proof. ir. red. ir.  
  assert (forall a, inc a Bnat -> cardinal_le (succ a) a -> False).
  ir. bwi H2. rwi lt_n_succ_le0 H3. nin H3. elim H4. tv. nin H2. am. am.
  assert (inc card_two Bnat). fprops. cp (card_two_not_zero).
  assert (cardinal_le card_two card_two). fprops.
  assert (is_cardinal n). fprops. assert (is_cardinal m). fprops.
  nin (cardinal_le_total_order2 H7 H6).
  cp (product_increasing2 H8 H5). wri H1 H9. 
  assert (inc (card_mult n card_two) Bnat). fprops. app (H2 _ H10 H9).
  wri lt_n_succ_le0 H8. cp (product_increasing2 H8 H5). wri H1 H9. ufi succ H9.
  rwi cardinal_distrib_prod_sum2 H9. set (a:= card_mult n card_two) in *.
  awi H9. rwi card_two_pr H9. rwi card_plus_associative H9.
  set (b:= card_plus a card_one) in *. change (cardinal_le (succ b) b) in H9.
  assert (inc a Bnat). uf a. fprops. assert (inc b Bnat). uf b. fprops.
  app (H2 _ H11 H9). fprops. am. fprops.
Qed.

Lemma even_odd_aux1: forall n m, 
  inc n Bnat -> inc m Bnat ->
  succ (card_mult card_two n) <> (card_mult card_two m).
Proof. ir. rw card_mult_commutative. rw (card_mult_commutative card_two m).
  app  even_odd_aux.
Qed.

Lemma less_than_two: forall a, cardinal_lt a card_two ->
  a = card_zero \/ a = card_one.
Proof. ir. rwi card_two_pr H. change (cardinal_lt a (succ card_one)) in H.
  assert (is_finite_c card_one). fprops. rwi (lt_is_le_succ a H0) H.
  nin (equal_or_not a card_one). au. assert (cardinal_lt a card_one).
  split; am. wri succ_zero H2. assert (is_finite_c card_zero). fprops. 
  rwi (lt_is_le_succ a H3) H2. rw (zero_smallest2 H2). au.
Qed.

Lemma even_odd_succ: forall n,
  (even_int n -> odd_int (succ n)) & (odd_int n -> even_int (succ n)).
Proof. ir. assert (inc card_two Bnat). fprops.  cp (card_two_not_zero).
  split. ir. red in H1. ee. assert (inc (succ n) Bnat). fprops. split. am. 
  red. ir. red in H4. ee.  cp (Bnat_division H1 H H0). 
  cp (Bnat_division H3 H H0). ee. rwi H2 H11. rwi H5 H9.
  red in H11. red in H9. ee.
  set (q1:= card_quo n card_two) in H11. 
  set (q2:= (card_quo (succ n) card_two)) in H9. awi H9. awi H11. rwi H11 H9.
  cp (even_odd_aux1  H10 H8).  elim H14. am. fprops. fprops.
  ir. nin H1. cp (Bnat_division H1 H H0). ee. red in H5. ee.
  ufi even_int H2. set (r := card_rem n card_two). assert (r <> card_zero).
  dneg. au. fold r in H6. nin (less_than_two H6). contradiction. 
  fold r in H5. set (q:= card_quo n card_two) in H5. rwi H8 H5.
  split. fprops.
  assert (inc (succ n) Bnat). fprops. cp (Bnat_division H9 H H0). ee.
  assert (division_prop (succ n) card_two (succ q) card_zero).
  red. ee. aw. uf succ. rw H5. rw cardinal_distrib_prod_sum3. aw.
  wr card_plus_associative. wr card_two_pr. tv. fprops. fprops.
  split. app zero_smallest. fprops. fprops. assert (inc (succ q) Bnat). fprops.
  nin (division_unique H9 H H11 H10 H14 inc0_Bnat H0 H12 H13). am.
Qed.

Lemma Exercice2_7A7:  
  is_closure (BL (fun z => Yo (even_int z) z (succ z)) Bnat Bnat) Bnat_order.
Proof. cp substrate_Bnat_order. nin worder_Bnat_order.
  assert (transf_axioms (fun z => Yo (even_int z) z (succ z)) Bnat Bnat).
  red. ir. nin (p_or_not_p  (even_int c)). rww Y_if_rw. rww Y_if_not_rw.
  fprops. red. ir. ee. red. eee. app af_function. ir.
  rwi related_Bnat_order H3. red in H3. ee. rw related_Bnat_order. red. 
  aw. ee. app H2. app H2. nin (p_or_not_p (even_int x)). rww Y_if_rw.
  nin (p_or_not_p (even_int y)). rww Y_if_rw. rww Y_if_not_rw. 
  assert (is_cardinal y). fprops. cp (is_less_than_succ H8). co_tac.
  rww Y_if_not_rw. nin (p_or_not_p (even_int y)). rww Y_if_rw. 
  assert (cardinal_lt x y). split. am. dneg. ue. srw. fprops. fprops.
  rww Y_if_not_rw. wrr lt_n_succ_le1. fprops. fprops. ir.
  rw related_Bnat_order. red. rwi H H3. aw. ee. am. app H2.
  nin (p_or_not_p  (even_int x)). rww Y_if_rw. fprops. rww Y_if_not_rw.
  app is_less_than_succ.  fprops. ir. rwi H H3.
  set (t:= W x (BL (fun z : Set => Yo (even_int z) z (succ z)) Bnat Bnat)).
  assert (t = Yo (even_int x) x (succ x)).  uf t. aw.
  nin (p_or_not_p (even_int x)). rwi Y_if_rw H4. rww H4.  am.
  rwi Y_if_not_rw H4. rw H4. aw. rw Y_if_rw.  tv.
  nin (even_odd_succ x). app H7. split. am. am. fprops. am.
Qed.

Lemma Exercice2_7A8:  
  is_closure (BL (fun z => Yo (even_int z) (succ z) z) Bnat Bnat) Bnat_order.
Proof. cp substrate_Bnat_order. nin worder_Bnat_order.
  assert (transf_axioms (fun z => Yo (even_int z) (succ z) z) Bnat Bnat).
  red. ir. nin (p_or_not_p  (even_int c)). rww Y_if_rw. fprops.
  rww Y_if_not_rw.
  red. ir. ee. red. eee. app af_function. ir.
  rwi related_Bnat_order H3. red in H3. ee. rw related_Bnat_order. red. 
  aw. ee. app H2. app H2. nin (p_or_not_p (even_int x)). rww Y_if_rw.
  nin (p_or_not_p (even_int y)). rww Y_if_rw. wrr lt_n_succ_le1.
  fprops. fprops. rww Y_if_not_rw. assert (cardinal_lt x y). split. am. dneg. 
  ue. srw. fprops. fprops.
  rww Y_if_not_rw. nin (p_or_not_p (even_int y)). rww Y_if_rw. 
  assert (is_cardinal y). fprops. cp (is_less_than_succ H8). co_tac.
  rww Y_if_not_rw. fprops.
  ir. rw related_Bnat_order. red. rwi H H3. aw. ee. am. app H2.
  nin (p_or_not_p  (even_int x)). rww Y_if_rw. app is_less_than_succ.  
  fprops. rww Y_if_not_rw.  fprops. ir. rwi H H3.   
  set (t:= W x (BL (fun z : Set => Yo (even_int z) (succ z) z) Bnat Bnat)).
  assert (t = Yo (even_int x) (succ x) x).  uf t. aw.
  nin (p_or_not_p (even_int x)). rwi Y_if_rw H4. rw H4. aw.  rww Y_if_not_rw.  
  nin (even_odd_succ x). nin (H6 H5). am. fprops. am. 
  rwi Y_if_not_rw H4. rww H4. am.
Qed.

Lemma Exercice2_7A9: forall x w,
  let u :=BL (fun z => Yo (even_int z) (succ z) z) Bnat Bnat in
    let v :=BL (fun z => Yo (even_int z) z (succ z)) Bnat Bnat in
      inc x Bnat ->
      cardinal_le (W x u) w ->
      cardinal_le (W x v) w ->
      x <> w.
Proof. ir. cp H. bwi H. nin H. 
  cp (is_less_than_succ H). dneg. ufi u H0. ufi v H1.
  nin (p_or_not_p (even_int x)). awi H0.  
  rwi Y_if_rw H0. wri H5 H0. co_tac. am. red. ir.
  nin (p_or_not_p (even_int c)). rww Y_if_rw. fprops. rww Y_if_not_rw. am.
  awi H1. rwi Y_if_not_rw H1. wri H5 H1. co_tac. am. red. ir.
  nin (p_or_not_p (even_int c)). rww Y_if_rw. rww Y_if_not_rw. fprops. am.
Qed.

Lemma Exercice2_7A10: exists r, exists u, exists v,
  order r & inductive_set r & 
  inc u (set_of_closures r) & inc v (set_of_closures r)
  & ~  has_supremum (closure_ordering r) (doubleton u v).
Proof. cp Exercice2_7A9. simpl in H.
  cp Exercice2_7A7. cp Exercice2_7A8.
  set (u :=BL (fun z => Yo (even_int z) (succ z) z) Bnat Bnat) in *.
  set (v :=BL (fun z => Yo (even_int z) z (succ z)) Bnat Bnat) in *.
  cp (Exercice2_7A6 H0). cp (Exercice2_7A6 H1).
  set (u1:=  extension_to_NNstar u) in *.
  set (v1:=  extension_to_NNstar v) in *.
  exists NNstar.  exists (corr_value u1). exists (corr_value v1).
  nin Exercice2_7A3. cp Exercice2_7A4. split. am. split. am.
  assert (forall w, is_closure w NNstar -> 
    inc (corr_value w) (set_of_closures NNstar)). ir.
  assert (w = sof_value (substrate NNstar) (substrate NNstar) (corr_value w)).
  nin H7. red in H7. ee.
  assert (w = sof_value (source w) (target w) (corr_value w)).
  uf corr_value. uf sof_value. aw. sy. app corr_propc.
  wri H12 H16; wri H13 H16. am. uf set_of_closures. Ztac. nin H7. red in H7. ee.
  app inc_set_of_functionsc. ue. cp (H7 _ H2).  cp (H7 _ H3). eee.
  red. ir. nin (Exercise2_7b H4).
  wri H13 H8; wri H13 H9. cp (sup_pr H12 H9 H8 H11).
  set (su := sup (closure_ordering NNstar) (corr_value u1) (corr_value v1))
    in *. ee. rwi  Exercise2_7a H14.  rwi  Exercise2_7a H15. 
  ee.
  assert (u1 =sof_value (substrate NNstar) (substrate NNstar) (corr_value u1)).
  uf corr_value. uf sof_value. aw.
  assert (v1 =sof_value (substrate NNstar) (substrate NNstar) (corr_value v1)).
  uf corr_value. uf sof_value. aw.  wri H21 H20. wri H22 H18.
  ufi set_of_closures H19. Ztac. clear H19. 
  set (w:= sof_value (substrate NNstar) (substrate NNstar) su) in *.
  red in H24. ee.
  assert (function_prop u Bnat Bnat). red. ee. red in H1. ee. red in H1. ee. 
  am. tv. tv. nin (Exercice2_7A5  H26).
  assert (function_prop v Bnat Bnat). red. ee. red in H0. ee. red in H0. ee. 
  am. tv. tv. nin (Exercice2_7A5  H29).
  assert (forall x, inc x Bnat -> Q (W (J x TPa) w) = TPb). ir.
  assert (inc  (J x TPa) (substrate NNstar)). rw H5. 
  rw canonical_du2_pr. ee. fprops. aw. au.
  assert (inc (W (J x TPa) w) (substrate NNstar)). red in H19. ee. rw H39.
  app inc_W_target. rwi H5 H34. rwi canonical_du2_pr H34. ee. nin H35. ee.
  assert (Hr:=H25 _ H33).
  set (y := P (W (J x TPa) w)). assert (J y TPa = W (J x TPa) w).
  app pair_extensionality. fprops. aw. aw. sy; am. wri H39 Hr.
  assert (inc (J y TPa) (substrate NNstar)).  rw H5. 
  rw canonical_du2_pr. ee. fprops. aw. au.
  cp (H20 _ H40). cp (H18 _ H40). ufi u1 H41. ufi v1 H42. fold y in H35.
  rwi (H30 _ H35) H42.  rwi (H27 _ H35) H41.
  rwi H10 H41. rwi H10 H42. ee. nin H46. awi H46. ee.
  nin H44. awi H44. ee. 
  cp (Exercice2_7A9 H35 H48 H50). 
  rwi Hr H51. awi H51. elim H51. tv. ee. nin H44. ee. contradiction.
  ee. contradiction. nin H46. ee. awi H46. elim H46. tv. nin H46.
  rwi Hr H47. awi H47. elim H47. tv. nin H35. am.

  cp (H32 _ inc0_Bnat). set (k:= W (J card_zero TPa) w).
  assert (inc (J card_zero TPa) (substrate NNstar)). rw H5. rw canonical_du2_pr.
  ee. fprops. left. aw. eee.
  assert (inc k (substrate NNstar)). red in H19. ee. rw H40. 
  uf k. app inc_W_target.
  assert (inc (P k) Bnat). rwi H5 H35. rwi canonical_du2_pr H35. nin H35. 
  nin H36; nin H36; am.
  assert (forall x, gle NNstar x k -> W x w = k).
  ir. assert (gle NNstar (J card_zero TPa) x).  rw H10. ee. ue.  wr H5.
  order_tac. aw. assert (inc x (substrate NNstar)). order_tac. 
  rwi H5 H40. rwi canonical_du2_pr H40. ee. nin H41. left. ee. tv. am.
  app zero_smallest. fprops.  right. right. ee. tv. rw H42. fprops.
  red in H19. ee. cp (H45 _ _ H38). cp (H45 _ _ H37). ufi k H47.
  rwi (H25 _ H34) H47. uf k. order_tac.
  set (k':= J (succ (P k)) TPb).
  assert (inc k' (substrate NNstar)). uf k'. rw H5. rw canonical_du2_pr.
  split. fprops. right. aw. split. fprops. tv.
  assert (glt NNstar k' k). split.  rw H10. ee. ue. ue.
  uf k'. aw. right. left. ee. fprops. uf k. rw H33. fprops.
  app is_less_than_succ. fprops. uf k'. red. ir. cp (f_equal P H39). 
  awi H40. bwi H36. nin H36. symmetry in H40. contradiction.

  set (ww := fun z=> Yo (gle NNstar z k') k' (W z w)).
  assert (transf_axioms ww (substrate NNstar) (substrate NNstar)).
  red. ir. uf ww. nin (p_or_not_p  (gle NNstar c k')). rww Y_if_rw.
  rw Y_if_not_rw. red in H19. ee. rw H47. app inc_W_target. am.
  set (w' := BL ww (substrate NNstar) (substrate NNstar)).
  assert (is_function w'). uf w'. app af_function.

  assert (forall x, inc x (substrate NNstar) ->
    (gle NNstar (W x u1)  (W x w') &  gle NNstar (W x v1)  (W x w'))). 
  ee. ir. cp H44. rwi H5 H44. rwi canonical_du2_pr H44. nin H44. nin H46. 
  nin H46. assert (x = J (P x) (Q x)). aw. rwi H47 H48.
  cp (H27 _ H46). cp (H30 _ H46). fold u1 in H49. fold v1 in H50. 
  wri H48 H49. wri H48 H50. rw H49; rw H50. assert  (gle NNstar x k').
  rw H10. ee. ue. ue. right. right. ee. am. uf k'. aw. fprops.
  assert (W x w' = k'). uf w'. aw. uf ww. rww Y_if_rw. rw H52.
  split. rw H10. ee. rw canonical_du2_pr. ee. fprops. left. aw. ee.
  red in H26. ee. wr H54. app inc_W_target. tv. ue. right. right. uf k'.
  aw. eee. rw H10. ee. rw canonical_du2_pr. ee. fprops. left. aw. ee.
  red in H29. ee. wr H54. app inc_W_target. tv. ue. right. right. uf k'.
  aw. eee. nin H46. nin (p_or_not_p  (gle NNstar x k')).
  assert (W x w' = k'). uf w'. aw. uf ww. rww Y_if_rw. rw H49.
  uf u1. rw (H28 _ H45 H47). uf v1.  rw (H31 _ H45 H47). au.
  assert (W x w' = W x w). uf w'. aw. uf ww. rww Y_if_not_rw. rw H49.
  ee. app H20. app H18.

  assert (is_closure w' NNstar). red. ee. red. eee. ir.
  assert (inc x (substrate NNstar)). order_tac.
  assert (inc y (substrate NNstar)). order_tac. red in H19. ee.
  cp (H52 _ _ H45). nin (p_or_not_p  (gle NNstar y k')).
  assert (gle NNstar x k'). order_tac. uf w'. aw. uf ww. rww Y_if_rw. 
  rww Y_if_rw. order_tac. assert (W y w' = W y w).  uf w'. aw. uf ww.
  rw Y_if_not_rw. tv. am. rw H55.
  nin (p_or_not_p (gle NNstar x k')). uf w'. aw. uf ww. rww Y_if_rw.
  assert (gle NNstar k' y). rw H10. ee. ue. ue.
  rwi H5 H47. rwi canonical_du2_pr H47. nin H47. nin H57. nin H57.
  elim H54. rw H10. ee. rw canonical_du2_pr.  au. ue. right. right. eee.
  uf k'. aw. fprops. right. left. ee. uf k'. aw. fprops. rw H58. fprops.
  assert (is_cardinal (P y)). fprops. assert (is_cardinal (P k')).
  uf k'. aw. fprops. nin (cardinal_le_total_order3 H59 H60). am.
  elim H54. rw H10. ee. rw canonical_du2_pr.  au. ue. right. left.
  ee. rw H58. fprops. uf k'. aw. fprops. am.
  cp (H52 _ _ H57). cp (H24 _ H38). order_tac. uf w'. aw. uf ww.
  rww Y_if_not_rw.
  ir. uf w'. aw. uf ww.  nin (p_or_not_p (gle NNstar x k')). rww Y_if_rw.
  rww Y_if_not_rw. app H24. ir.
  nin (p_or_not_p (gle NNstar x k')). assert (W x w' = k').
  uf w'. aw. uf ww. rww Y_if_rw. rw H47. uf w'. aw. uf ww.  rww Y_if_rw. 
  order_tac. assert (W x w' = W x w). uf w'. aw. uf ww. rww Y_if_not_rw.
  set (y :=  W x w'). assert (~ gle NNstar y k'). uf y. rw H47. dneg.
  cp (H24 _ H45). order_tac. uf w'. aw. uf ww. rww Y_if_not_rw.
  uf y.  rw H47. app H25. uf y. cp (H24 _ H45). rw H47. order_tac.
  cp (H7 _ H43).
  assert (w' =sof_value (substrate NNstar) (substrate NNstar) (corr_value w')).
  uf corr_value. uf sof_value. aw.
  assert (gle (closure_ordering NNstar) (corr_value v1) (corr_value w')).
  rw Exercise2_7a. ee. am. am. ir. wr H22; wr H45. nin (H42 _ H48). am. am.
  assert (gle (closure_ordering NNstar) (corr_value u1) (corr_value w')).
  rw Exercise2_7a. ee. am. am. ir. wr H21; wr H45. nin (H42 _ H49). am. am.
  cp (H16 _ H47 H46). rwi Exercise2_7a H48. ee. cp (H50 _ H34).
  wri H45 H53. fold w in H53. fold k in H53. ufi w' H53. awi H53. ufi ww H53.
  rwi Y_if_rw H53. order_tac. rw H10. ee. ue. ue. uf k'. right. right. aw.
  ee. tv. fprops. am. am. am. am. am.
Qed.

(* Exercise 8 *)
Definition is_ramified r :=
  forall x y, glt r x y -> exists z, glt r x z & ~ gle r y z&  ~ gle  r z y.

Definition is_ramified_c r :=
  is_ramified r & not (exists x, maximal_element r x).

Lemma Exercise2_8a: forall r, order r -> anti_directed r -> is_ramified r.
Proof. ir. rwi (Exercise1_23h H) H0. nin H0. red. ir. nin (H0 _ _ H2).
  nin H3. exists x0. ee. am. 
  red. ir. assert (gle r x0 x0). order_tac. order_tac. app (H4 _ H5 H6). 
  red. ir. assert (gle r y y). order_tac. order_tac. app (H4 _ H6 H5). 
Qed.

Definition  Exercise2_8a_R r a :=
  Zo (powerset (substrate r))
  (fun z => is_ramified (induced_order r z) & 
    least_element  (induced_order r z) a).

Lemma Exercise2_8b: forall r a F, order r ->
  inc F (Exercise2_8a_R r a) =
  (sub F (substrate r)
    &  (forall x y, glt r x y -> inc x F -> inc y F -> 
      exists z, glt r x z & ~ gle r y z&  ~ gle  r z y & inc z F)
    & inc a F
    & (forall z, inc z F -> gle r a z)).
Proof. ir. assert (forall F u v, sub F (substrate r) ->
  gle (induced_order r F) u v =   (inc u F & inc v F & gle r u v)).
  ir. ap iff_eq. ir. cp (related_induced_order1 H1).  
  cp (related_induced_order3 H1). nin H3. au. ir. ee. aw.
  assert (forall F u v, sub F (substrate r) ->
  glt (induced_order r F) u v =   (inc u F & inc v F & glt r u v)).
  ir. uf glt. ap iff_eq. ir. rwi H0 H2. eee. am. ir. rww H0. eee.
  uf Exercise2_8a_R. uf is_ramified. ap iff_eq; ir; Ztac.
  nin H4. rwi powerset_inc_rw H3. red in H5. awii H5. nin H5.
  ee. am. ir. assert (glt (induced_order r F) x y). rww H1. au.
  nin (H4 _ _ H10). ee. exists x0.  rwi H1 H11. ee. am. clear H13. dneg.
  rww H0. au. dneg. rww H0. au. am. am. am. ir. cp (H6 _ H7). 
  rwii H0 H8. eee. 
  ap powerset_inc. eee. ee. ir. rwi H1 H6. ee. nin (H3 _ _ H8 H6 H7).
  exists x0. ee. rw H1. eee. am. clear H11. dneg. rwii H0 H11.  eee.
  dneg. rwii H0 H13.  eee. am. red. aw. ee. am. ir. rww H0. eee.
Qed.

Lemma Exercise2_8c: forall r a, order r -> inc a (substrate r) ->
  exists A, maximal_element (inclusion_suborder  (Exercise2_8a_R r a)) A.
Proof. ir. app Zorn_lemma. fprops. red. aw. ir.
  nin H2. set (F := Exercise2_8a_R r a) in *. 
  assert (order (inclusion_suborder F)). fprops.
  assert (sub X (substrate (inclusion_suborder F))). aw. awii H3.
  assert (forall x y, inc x X -> inc y X -> sub x y \/ sub y x).
  ir. nin (H3 _ _ H6 H7). awii H8. ee; au. red in H8. awii H8. ee; au. 
  nin (emptyset_dichot X). exists (singleton a).
  red. split. aw.  uf F. rw Exercise2_8b. ee. app sub_singleton.
  ir. awi H9. awi H10. nin H8. elim H11. ue. fprops. ir. awi H8. rw H8.
  order_tac. am. ir. aw. rwi H7 H8. elim (emptyset_pr H8).
  assert (inc (union X) F). uf F. rw  Exercise2_8b. awi H5.
  ee. red. ir. nin (union_exists H8). nin H9. cp (H1 _ H10).
  ufi F H11. rwi  Exercise2_8b H11. ee. app H11. am.
  ir. nin (union_exists H9). nin (union_exists H10). ee.
  assert (exists z, inc z X & inc x z & inc y z). nin (H6 _ _ H13 H14).
  exists x0. eee. exists x1. eee. nin H15. ee.
  cp (H1 _ H15). ufi F H18.  rwi  Exercise2_8b H18. ee.
  nin (H19 _ _ H8 H16 H17). ee. exists x3. eee. union_tac. am. 
  nin H7. cp (H1 _ H7).  ufi F H8. rwi  Exercise2_8b H8. ee. union_tac. am.
  ir. nin (union_exists H8). nin H9. cp (H1 _ H10).  ufi F H11. 
  rwi Exercise2_8b H11. ee.  app H14. am. am.
  exists (union X). red. aw. split. am. ir. aw. eee. app union_sub.
Qed.

Conjecture Exercise2_8d: forall r a A, order r -> inc a (substrate r) ->
  branched r ->
  maximal_element (inclusion_suborder  (Exercise2_8a_R r a)) A
  -> is_ramified_c (induced_order r A).

(* Exercise 9 *)

Lemma ordinal_sum_wo_pr : forall r f g,
  ordinal_sum_axioms1 r f g ->  worder (ordinal_sum r f g) ->
  (worder r &  (forall i, inc i (domain f) -> worder (V i g))).
Proof. ir. nin H. cp H. red in H. ee. split. am. ir.
  set (y := fun_image x  (fun z => (J (rep (V z f)) z))).
  assert (sub y (substrate (ordinal_sum r f g))). aw. red. ir.
  ufi y H11. awi H11. nin H11. nin H11. wr H12. app inc_disjoint_union.
  wr H3. app H9. app nonempty_rep. app H1.  wr H3. app H9.
  assert (nonempty y). nin H10. exists (J (rep (V y0 f)) y0). uf y. aw.
  ex_tac. nin H0. nin (H13 _ H11 H12). nin H14. awii H14. awii H15.
  assert (inc (Q x0) x). ufi y H14. awi H14. nin H14. nin H14. wr H16. aw.
  exists (Q x0). split. aw. aw. ir. aw. 
  assert (inc  (J (rep (V x1 f)) x1) y). uf y. aw. ex_tac.
  cp (H15 _ H18). awi H19. ee. nin H21. nin H21. am. nin H21. rw H21.
  order_tac. app H9. am. am. am.
  ir. split. app H7. ir.  
  set (y := fun_image x  (fun z => (J z i))).
  assert (sub y (substrate (ordinal_sum r f g))). aw. red. ir.
  ufi y H12. awi H12. nin H12. nin H12. wr H13. app inc_disjoint_union. wrr H8.
  app H10. assert (nonempty y). nin H11. exists (J y0 i). uf y. aw.
  ex_tac. nin H0. nin (H14 _ H12 H13). nin H15. awii H15. awii H16.
  assert (inc (P x0) x). ufi y H15. awi H15. nin H15. nin H15. wr H17. aw.
  exists (P x0). split. aw. app H7. aw. ir. aw. 
  assert (inc (J x1 i) y). uf y. aw. ex_tac.
  cp (H16 _ H19). awi H20. ee. ufi y H15. awi H15. nin H15. nin H22. nin H15.
  wri H23 H22. awi H22. nin H22. elim H24. tv.  nin H22. wrr H22. am. am. am.
  app H7.
Qed.

Lemma worder_decreasing_finite: forall r r' f,
  worder r -> worder r' ->
  (forall i, inc i (substrate r) -> inc (f i) (substrate r')) ->
  (forall i j, glt r i j -> glt r' (f j) (f i)) ->
  is_finite_set (substrate r).
Proof. ir. assert (forall X, sub X (substrate r) -> nonempty X ->
  exists a, inc a X & forall b, inc b X -> gle r b a).
  ir. set (Y := fun_image X f). assert (sub Y (substrate r')).
  red. ir. ufi Y H5. awi H5. nin H5. nin H5. wr H6. app H1. app H3.
  assert (nonempty Y). nin H4. exists (f y). uf Y. aw. ex_tac.
  nin H0. nin (H7 _ H5 H6). red in H8. awii H8. nin H8. ufi Y H8. awi H8. 
  nin H8. nin H8. exists x0. split. am. ir. assert (inc (f b) Y). uf Y.
  aw. ex_tac. cp (H9 _ H12).  cp (related_induced_order1 H13). wri H10 H14.
  cp (worder_total H). nin H15. nin (H16 _ _ (H3 _ H8) (H3 _ H11)).
  nin (equal_or_not x0 b). rw H18. order_tac. app H3.
  assert (glt r x0 b). split; am. cp (H2 _ _ H19). order_tac. am.
  cp  worder_Bnat_order.  nin (isomorphism_worder H4 H). nin H5. nin H5.
  nin H5. clear H6. nin H5. red in H7. ee. nin H9.
  assert (nonempty (range (graph x))).  exists (W card_zero x). aw. 
  exists card_zero. graph_tac. wr H10. rw substrate_Bnat_order. fprops. fprops.
  nin (H3 _ H5 H14). nin H15. awi H15. nin H15.  
  assert (inc x1 (source x)). graph_tac. 
  assert (source x = Bnat). wr H10. rww substrate_Bnat_order.
  assert (inc (succ x1) (source x)). rwi H18 H17. rw H18. fprops.
  assert (gle Bnat_order x1 (succ x1)). rw related_Bnat_order. red. ee.
  wrr H18. wrr H18. app is_less_than_succ. rwi H18 H17. fprops.
  rwi (H12 _ _ H17 H19) H20.
  assert (x0 = W x1 x). sy.  app W_pr. wri H21 H20.
  assert (inc  (W (succ x1) x) (range (graph x))). aw. exists (succ x1).
  graph_tac. fprops. cp (H16 _ H22). assert ( x0 = W (succ x1) x). order_tac.
  rwi H21  H24. cp (H13 _ _ H17 H19  H24). rwi H18 H17. bwi H17.
  nin H17. contradiction. fprops.
  nin H5. nin H5. clear H6. nin H5. nin (well_ordered_segment H4 H5).
  rwi substrate_Bnat_order H7.
  cp (@sub_refl  (substrate r)).
  nin (emptyset_dichot (substrate r)). rw H9.  app emptyset_finite.
  nin (H3 _ H8 H9). nin H10. red in H6. ee. assert (inc (W x0 x) Bnat).
  wr H7. nin H13.  aw. exists x0. graph_tac. ue. fprops.
  assert (inc  (succ (W x0 x)) Bnat). fprops. cp H18. wri H7  H19. awi H19.
  nin H19.  assert (W x1 x =  (succ (W x0 x))). app W_pr. fct_tac.
  assert (inc x1 (substrate r)). rw H14. nin H13;graph_tac.
  cp (H11 _ H21). wri H14 H16. rwi (H16 _ _ H21 H10) H22.
  rwi related_Bnat_order H22. red in H22. ee. rwi H20 H24.
  rwi lt_n_succ_le H24. nin H24. elim H25. tv. am. am. nin H13. fprops. 
  nin H7. nin H7.  rwi substrate_Bnat_order H7. rwii segment_Bnat_order H8.
  assert (is_finite_set (range (graph x))). rw H8.
  app finite_set_interval_co. nin H6. ee.  cp (equipotent_range H11).
  red in H9. red. 
  assert (cardinal (substrate r) = cardinal (range (graph x))). rw H12. aw.
  rww H16.
Qed.

Lemma worder_lexicographic_order_bis: forall r f g,
  lexicographic_order_axioms r f g ->
  worder (lexicographic_order r f g) ->
  (forall i, inc i (domain g) ->  exists x, exists y, glt (V i g) x y) ->
  ((forall i, inc i (domain g) -> worder (V i g)) &
  is_finite_set (substrate r)).
Proof. ir. cp H. red in H. 
  set (f0 := fun i => choose (fun z =>  glt (V i g) (P z) (Q z))).
  assert (forall i, inc i (domain g) ->  glt (V i g) (P (f0 i)) (Q (f0 i))).
  ir. uf f0. app choose_pr. nin (H1 _ H3). nin H4. exists (J x x0). aw.
  ee. ir.  split. app H8. ue. 
  ir.  set (f1 := fun j => P (f0 j)). 
  assert (Ha: order (V i g)). app H8. ue.
  assert (forall j, inc j (domain f) -> inc (f1 j) (V j f)).
  ir. wr H9. rwi H7 H13. cp (H3 _ H13). order_tac. am.
  set (f3:= fun a  => L (domain f) (fun j => Yo (j = i) a (f1 j))).
  assert (forall a , inc a (V i f) -> 
    inc (f3 a) (substrate (lexicographic_order r f g))).
  ir. aw. uf f3. rw productb_pr. ee. gprops. bw. bw. ir. bw.
  nin (equal_or_not i0 i). rww Y_if_rw. ue. rww Y_if_not_rw. app H13. am.
  set (X:= fun_image x f3).
  assert (sub X (substrate  (lexicographic_order r f g))).
  red. ir. ufi X H15. awi H15. nin H15. nin H15. wr H16. app H14. wrr H9. 
  app H11. ue. assert (nonempty X). nin H12. exists (f3 y). uf X. aw. ex_tac.
  nin H0. nin  (H17 _ H15 H16). nin H18. awii H18. awii H19.
  ufi X H18. awi H18. nin H18. nin H18.
  exists x1. split. aw. ir. awii H21. aw. 
  assert (inc (f3 x2) X). uf X. aw. ex_tac. cp (H19 _ H22).
  cp (related_induced_order1 H23). awi H24. ee.
  assert (Hb : V i x0 = x1). wr H20. uf f3. bw. rww Y_if_rw. ue. 
  assert (Hc : V i (f3 x2) = x2). uf f3. bw. rww Y_if_rw. ue. 
  nin (equal_or_not x1 x2). wr H27. order_tac. app H11. nin H.
  assert (least_element  (induced_order r
             (Zo (domain f) (fun i : Set => V i x0 <> V i (f3 x2)))) i).
  split. aw. Ztac. ue.  rw Hc. rw Hb. am. rw H4. app Z_sub. aw. ir. 
  nin (equal_or_not x3 i). aw. rw H30. 
  order_tac.  ue. ue. wrr H30. Ztac. wri H20 H32. ufi f3 H32. bwi H32.
  rwii Y_if_not_rw H32. rwii Y_if_not_rw H32. elim H32. tv. am. am. 
  rw H4. app Z_sub. cp (H26 _ H29). nin H30. rwi Hb H30. rwi Hc H30. am. am.
  set (f1 := fun i =>  L (domain f) 
    (fun z => Yo (glt r z i) (P (f0 z)) (Q (f0 z)))).
  assert (forall i, inc i (domain f) -> inc (f1 i) (productb f)).
  ir. rw productb_pr. uf f1. split. gprops. bw. split. tv. ir. bw.
  wrr H9. cp (H8 _ H11). rwi H7 H11. cp (H3 _ H11).
  nin (p_or_not_p (glt r i0 i)). rww Y_if_rw. order_tac. rww Y_if_not_rw.
  order_tac. am.
  assert (forall i j, glt r i j ->
    glt (lexicographic_order r f g) (f1 j) (f1 i)).
  ir. nin H. assert (inc i (substrate r)). order_tac.
  assert (inc j (substrate r)). order_tac.
  assert (inc i (domain f)). ue. assert (inc j (domain f)). ue.
  assert (V i (f1 i)  = (Q (f0 i))). uf f1. bw. rww Y_if_not_rw. red. ir.
  nin H17. elim H18. tv.
  assert (V i (f1 j)  = (P (f0 i))). uf f1. bw. rww Y_if_rw. 
  assert (inc i (domain g)). ue. cp (H3 _ H19).
  split. aw. ee. app H10. app H10. ir. 
  assert (inc i (domain g)). ue. 
  set (E:= Zo (domain f) (fun i0  => V i0 (f1 j) <> V i0 (f1 i))) in *.
  assert (sub E (substrate r)). rw H4. uf E. app Z_sub. red in H21.
  awii H21. nin H21. assert (inc i E). uf E. Ztac. rw H17. rw H18. nin H20; am.
  cp (H24 _ H25). nin (equal_or_not j0 i). rw H27. rw H17. rww H18.
  cp (related_induced_order1 H26). assert (glt r j0  i). split. am. am.
  cp (related_induced_order3 H26). nin H30. ufi E H30. Ztac.
  ufi f1 H33. bwi H33. rwii Y_if_rw H33. rwii Y_if_rw H33.
  elim H33. tv. order_tac. am. am. red. ir. wri H17 H20. wri H18 H20.
  rwi H21 H20. nin H20. elim H22. tv.
  assert (forall i, inc i (substrate r) -> 
    inc (f1 i) (substrate (lexicographic_order r f g))).
  ir. aw. app H10. ue.
  app (worder_decreasing_finite _ H H0 H12 H11).
Qed.

(* Chapter 6 ; exercise 1 *)

Lemma Exercise_6_1: forall  E, infinite_set E =
  (forall f, is_function f -> source f = E -> target f = E ->
    exists F, sub F E & nonempty F & F <> E & sub (image_by_fun f F) F).
Proof. ir. ap iff_eq. ir.
  nin (emptyset_dichot E). rwi H3 H. red in H. red in H. ee. elim H4.
  rw cardinal_zero. app is_finite0. nin H3.
  assert (forall u, inc u E -> inc (W u f) E).
  ir. wr H2. app inc_W_target. ue. rename H4 into Ha.
  cp (induction_defined_pr (fun n : Set => W n f) y).
  cp (integer_induction_stable _ H3 Ha).
  set (g:=induction_defined (fun n : Set => W n f) y) in *. simpl in H4. ee.
  set (F:= target g).  nin H6.
  assert (inc y F). uf F. wr H7. app inc_W_target. ue.
  assert (sub (image_by_fun f F) F). uf F. red. ir. ufi image_by_fun H10.
  awi H11. nin H11. ee. wri H9 H11. ufi image_of_fun H11. awi H11. nin H11. ee.
  red in H13. wr H12. wr (W_pr H6 H13). wr H8.
  app inc_W_target. rw H4. rwi H4 H11.  fprops. wrr H4. fprops. ue.
  set (G:=image_by_fun f F). 
  exists G. ee.  apply sub_trans with F. app H11. app H5. uf G. 
  exists (W y f). aw. ex_tac. uf F. rww H1.
  red. ir. wri H12 H3. ufi G H3.
  ufi image_by_fun H3. awi H3. nin H3. nin H3. 
  ufi F H3. wri H9 H3. ufi image_of_fun H3. awi H3. nin H3. ee. 
  cp (W_pr H6 H14). cp (W_pr H0 H13). wri H15 H16. wri H8 H16. wri H7 H16.
  set (k:=  succ x0) in *. assert (inc k Bnat). uf k. rwi H4 H3. fprops.
  assert (forall i, inc i Bnat ->  W i g = W (card_plus i k) g).
  app cardinal_c_induction_v. wr H16. rww zero_unit_suml. fprops. ir. rw H8. 
  rw H19.
  assert (card_plus (succ n) k = succ (card_plus n k)). uf succ.
  rw (card_plus_commutative n card_one).
  wr card_plus_associative. app card_plus_commutative. rw H20. rww H8. fprops.
  am.  assert (forall i, inc i Bnat -> forall j, inc j Bnat ->  
  W i g = W (card_plus i (card_mult j k)) g). intros i H19. 
  ap cardinal_c_induction_v. rw card_mult_commutative. rw zero_prod_absorbing.
  rww zero_unit_sumr. fprops. ir. rw card_mult_commutative.
  rw mult_via_plus. rw card_plus_associative. wr H18. rww card_mult_commutative.
  fprops. fprops.
  assert (forall z, inc z E -> exists m, cardinal_lt m k & z = W m g). ir.
  wri H12 H20. ufi G H20. ufi image_by_fun H20. awi H20. nin H20. nin H20.
  red in H21. wr (W_pr H0 H21). ufi F H20. wri H9 H20. ufi image_of_fun H20.
  awi H20. nin H20. nin H20. red in H22. wr (W_pr H6 H22). wr H8.
  assert (inc (succ x2) Bnat). rwi H4 H20. fprops. assert (inc k Bnat).
  uf k. rwi H4 H3. fprops.  assert (k <> card_zero). uf k.
  cp (succ_positive x0). red in H25. ee. intuition.
  cp (division_exists H23 H24 H25). nin H26. nin H26. ee. red in H28. ee.
  rw H28. rw card_plus_commutative. exists x4.  split. am.
  rww card_mult_commutative. wr H19. tv. am. am. wrr H4. fprops. fprops.
  assert (sub E (image_by_fun g (interval_co_0a k))). red. ir.
  assert (inc k Bnat). uf k. rwi H4 H3. fprops.  nin (H20 _ H21). ee. 
  assert (inc x2 Bnat). red in H23. ee. rw inc_Bnat. rwi inc_Bnat H22.
  app (le_int_is_int H22 H23). uf image_by_fun. aw. 
  exists x2. ee. rww interval_co_0a_pr2.  
  red. rw H24. app defined_lem. rww H4. fprops.
  cp (cardinal_le8 H21). rwi cardinal_le3 H22.
  assert (is_finite_set (interval_co_0a k)). uf interval_co_0a.
  app finite_set_interval_co.
  assert (sub (interval_co_0a k) (source g)). rw H4. uf interval_co_0a.
  uf interval_co. rw substrate_Bnat_order. ap Z_sub.
  cp (finite_image_by H6 H24 H23). red in H25.
  set (w:= cardinal (image_by_fun g (interval_co_0a k)))  in *.
  cp (le_int_is_int H25 H22). red in H. red in H. ee. elim H27. am. wrr H4.
  fprops. fprops. uf image_by_fun. red. ir. awi H12. nin H12. nin H12.
  ufi G H12. ufi image_by_fun H12. awi H12. nin H12. nin H12.
  uf G. uf image_by_fun. aw. exists x0. split.  app H11. uf image_by_fun.
  aw. exists x1. eee. am. 

  ir. red. split. fprops. red. ir. set (n:= cardinal E). 
  assert (inc n Bnat). bw. 
  assert (equipotent E (interval_co_0a n)). wr cardinal_equipotent.
  rw cardinal_interval_co_0a1. tv. am. red in H2. nin H2. ee.
  set  (y:=inverse_fun x). 
  assert (nonempty E). set (f:=identity_fun E). 
  assert (is_function f). uf f.  app function_identity. assert (source f = E).
  tv. assert (target f = E). tv. nin (H _ H5 H6 H7). ee.
  nin H9. exists y0. app H8. assert (n <> card_zero). red. ee. ir. ufi n H6.
  elim (cardinal_nonemptyset1 H5). am.
  set (f:= fun i=> card_rem (succ i) n).
  assert (Ha: forall i, inc i Bnat -> inc (card_rem i n) (interval_co_0a n)).
  ir. rw interval_co_0a_pr2. cp (Bnat_division H7 H1 H6). 
  ee. red in H10; ee; am. am. 
  assert (Hb:sub  (interval_co_0a n)  Bnat). uf interval_co_0a.
  uf interval_co. rw substrate_Bnat_order. app Z_sub.
  assert (forall i, inc i (interval_co_0a n) -> inc (f i) (interval_co_0a n)).
  ir. uf f. app Ha. cp (Hb _ H7). fprops. 
  cp (inverse_bij_is_bij H2). cp (bij_is_function H2).
  cp (bij_is_function H8).
  set (g:= fun u => W (f  (W u x)) y). 
  assert (transf_axioms g E E). red.  ir. uf g. uf y. 
  assert (E = target (inverse_fun x)). simpl. sy; am. rw H12.
  app inc_W_target. simpl. rw H4. app H7. wr H4. app inc_W_target. ue.
  set (g1:= BL g E E). assert (is_function g1). uf g1. app af_function.
  assert (source g1 = E). tv. assert (target g1 = E). tv.
  nin (H _ H12 H13 H14). nin H15. nin H16. nin H17. nin H16.
  set (i:=W y0 x). assert (inc i Bnat). assert (inc i (target x)).
  uf i. app inc_W_target. ue. app Hb. ue.
  assert (inc (W i y) x0). uf i. uf y.
  set (xi:= W y0 x). assert (inc y0 (source x)). ue. 
  assert (xi =  W y0 x). tv. cp (W_inverse2 H2 H20 H21). ue.
  assert (forall j, inc j Bnat -> inc (W (card_rem (card_plus i j)n) y) x0).
  app cardinal_c_induction_v. rw  zero_unit_sumr.
  assert (card_rem i n = i). cp (Bnat_division H19 H1 H6). ee.
  assert (division_prop i n  card_zero i). red. split. rw zero_prod_absorbing.
  rww  zero_unit_suml. fprops.  assert (inc i (target x)).
  uf i. app inc_W_target. ue. rwi H4 H24. 
  rwi interval_co_0a_pr2 H24. am. am.
  nin (division_unique H19 H1 H22 H21 (inc0_Bnat) H19 H6 H23 H24). am. ue.
  fprops. ir.
  set (u:= card_rem (card_plus i n0) n) in *.
  assert (inc (W (W u y) g1) x0). app H18. aw. ex_tac. 
  ufi g1 H23. rwi W_af_function H23. ufi g H23.
  assert (W (W u y) x = u). sy. app W_inverse. rw H4. uf u. app Ha. fprops.
  rwi H24 H23. ufi f H23.
  assert (card_rem (succ u) n = card_rem (card_plus i (succ n0)) n).
  uf u. assert (inc (card_plus i n0) Bnat). fprops. 
  cp (Bnat_division  H25 H1 H6). ee. nin H28.
  set (q0:= card_quo (card_plus i n0) n) in H28.
  set (r0:= card_rem (card_plus i n0) n) in *. uf succ.
  rw card_plus_associative. rw H28. wr card_plus_associative. 
  set (r1:= card_plus r0 card_one). set (r2:= card_plus (card_mult n q0) r1).
  assert (inc r1 Bnat). uf r1. fprops. assert (inc r2 Bnat). uf r2. fprops.
  cp (Bnat_division H30 H1 H6). cp (Bnat_division H31 H1 H6). ee. 
  nin H37. 
  assert (r2= card_plus (card_mult n q0) r1). tv. rwi H37 H39. 
  rwi card_plus_associative H39. wri cardinal_distrib_prod_sum3 H39.
  set (q2:= (card_plus q0 (card_quo r1 n))).
  assert (division_prop r2 n q2 (card_rem r1 n)). red.  split. am. am.
  assert (inc q2 Bnat). uf q2. fprops.
  nin (division_unique H31 H1 H41 H32 H34 H33 H6 H40 H35). am. wr H25. am.
  am. app H15.
  elim H17. app extensionality. red. ir. assert (E = target y). sy; tv. 
  rwi H23 H22. red in H8. ee. fold y in H24.
  cp (surjective_pr2 H24 H22). nin H25. ee. wr H26. ufi y H25.
  simpl in H25. rwi H4 H25.
  assert (inc i (target x)). uf i. app inc_W_target.  ue. 
  rwi H4 H27.  rwi interval_co_0a_pr2 H27.
  set (j:= card_sub n i). nin H27. cp (card_sub_pr H1 H19 H27). fold j in H29.
  assert (inc j Bnat). uf j. fprops.
  set (k:= card_plus j x2).  assert (inc k Bnat). uf k. fprops.
  cp (H21 _ H31). assert (card_rem (card_plus i k) n = x2).
  assert (division_prop (card_plus i k) n card_one x2). red.
  rw one_unit_prodr. split. uf k. rw card_plus_associative. ue.
  rwi interval_co_0a_pr2 H25. eee. am. fprops.
  assert (inc (card_plus i k) Bnat). fprops.
  cp (Bnat_division H34 H1 H6). ee. 
  cp (division_unique H34 H1 (inc1_Bnat) (Hb _ H25) H36 H35 H6 H33 H37).
  ee. sy; am.  rwi H33 H32. am. am.
Qed. 


Lemma exercice6_2: forall a b c d, cardinal_lt a c ->
  cardinal_lt b d -> 
  (cardinal_lt (card_plus a b) (card_plus c d) & 
    cardinal_lt (card_mult a b) (card_mult c d)).
Proof. assert (forall a b c d, cardinal_le c d -> cardinal_lt a c ->
  cardinal_lt b d ->
  (cardinal_lt (card_plus a b) (card_plus c d) &
    cardinal_lt (card_mult a b) (card_mult c d))).
  ir.  assert (Ha:c <> card_zero). red. ir. rwi H2 H0. 
  app (zero_smallest1 H0). 
  nin (p_or_not_p (is_finite_c d)). ir.
  cp (le_int_is_int H2 H).
  assert (is_finite_c a). nin H0. Bnat_tac. 
  assert (is_finite_c b). nin H1. Bnat_tac.
  split. app finite_sum2_lt. bw. bw.  bw.  bw. 
  nin H0. am. app finite_prod2_lt.  bw. bw. bw. bw. nin H0. am.
  ir. assert (is_infinite_c d). red. ee.  nin H.  nin H3. am. am.
  rw (card_mult_commutative c d). rww (product2_infinite H H3 Ha). 
  rw (card_plus_commutative c d). rw (sum2_infinite H H3).
  nin (p_or_not_p (is_finite_c a)). ir. 
  nin (p_or_not_p (is_finite_c b)). ir.
  wri inc_Bnat H4; wri inc_Bnat H5.
  assert (is_finite_c (card_plus a b)). fprops. 
  assert (is_finite_c (card_mult a b)). fprops. 
  split. app finite_lt_infinite. app finite_lt_infinite.
  ir. assert (is_infinite_c b). red. ee. red in H1. ee.  red in H1; eee. am.
  cp  (finite_le_infinite H4 H6).
  split. rw card_plus_commutative. rw (sum2_infinite H7 H6). am.
  nin (equal_or_not a card_zero). rw H8.
  rw card_mult_commutative. rw zero_prod_absorbing.  app finite_lt_infinite.
  wr inc_Bnat. fprops. rw card_mult_commutative. 
  rww (product2_infinite H7 H6 H8). ir. assert (is_infinite_c a). red. ee. 
  red in H0. ee.  red in H0; eee. am.
  nin (p_or_not_p (is_finite_c b)). ir.
  cp  (finite_le_infinite H6 H5). split. rw (sum2_infinite H7 H5). 
  app (cardinal_lt_le_trans H0 H).
  nin (equal_or_not b card_zero). rw H8. rw zero_prod_absorbing.  
  app finite_lt_infinite. wr inc_Bnat. fprops. 
  rww (product2_infinite H7 H5 H8).  app (cardinal_lt_le_trans H0 H).
  ir. assert (is_infinite_c b). red. ee. red in H1. ee. red in H1; ee; am. am.
  assert (cardinal_le a b \/ cardinal_le b a).
  nin H0. nin H0. nin H1; nin H1. nin (cardinal_le_total_order1 H0 H1).
  left. rw H12. fprops. nin H12.  nin H12. left. am. nin H12. right. am.
  nin H8.  split. rw card_plus_commutative. rw (sum2_infinite H8 H7). am.
  nin (equal_or_not a card_zero). rw H9.
  rw card_mult_commutative. rw zero_prod_absorbing.  app finite_lt_infinite.
  wr inc_Bnat. fprops. rw card_mult_commutative. 
  rww (product2_infinite H8 H7 H9). rw (sum2_infinite H8 H5).  split.
  app (cardinal_lt_le_trans H0 H). nin (equal_or_not b card_zero). rw H9.
  rw zero_prod_absorbing.  app finite_lt_infinite. wr inc_Bnat. fprops. 
  rww (product2_infinite H8 H5 H9).  app (cardinal_lt_le_trans H0 H).
  ir. assert (cardinal_le c d \/ cardinal_le d c).
  red in H0. red in H1. ee. red in H0; red in H1; ee.
  nin (cardinal_le_total_order1 H6 H4).
  left. rw H8. fprops. nin H8.  nin H8. left. am. nin H8. right. am.
  nin H2. app H. 
  rw (card_plus_commutative c d). rw (card_mult_commutative c d).
  rw (card_plus_commutative a b). rw (card_mult_commutative a b). app H.
Qed.


Lemma Exercise6_3: forall E, infinite_set E ->
  equipotent (powerset E) (Zo (powerset E) (fun z => equipotent z E)).
Proof. ir. set (Qo:= Zo (powerset E) (fun z : Set => equipotent z E)).
  assert (sub Qo (powerset E)). uf Qo. app Z_sub.
  cp (cardinal_le8 H0). rwi cardinal_le3 H1.
  set (n:= cardinal E). assert (card_plus n n = n).
  assert (cardinal_le n n). uf n. fprops. red in H.  fold n in H. 
  ap (sum2_infinite H2 H).
  set (E1:= product E (singleton TPa)).  set (E2:= product E (singleton TPb)). 
  assert (equipotent E1 n). eqtrans E.  eqsym. uf E1. fprops. uf n. fprops.
  assert (equipotent E2 n). eqtrans E.  eqsym. uf E2. fprops. uf n. fprops.
  assert (disjoint E1 E2). uf E1; uf E2. app disjoint_union2_pr. fprops. 
  cp (card_plus_pr1 H5 H3 H4). rwi H2 H6. ufi n H6. awi H6. nin H6. ee.
  set (f:= fun X => image_by_fun x (union2 (product X (singleton TPa)) E2)).
  assert (forall X, sub X E -> sub (f X) E). red.  ir. ufi f H10.
  assert (is_function x). app bij_is_function.
  ufi image_by_fun H10. awi H10. nin H10. ee. red in H12. wr H8. 
  app (inc_pr2graph_target H11 H12). fprops.
  assert (forall X, sub X E -> equipotent (f X) E). ir.
  cp (H9 _ H10).  cp (cardinal_le8 H11). rwi cardinal_le3 H12.
  set (b:= image_by_fun x E2). assert (sub E2 (source x)). rw H7.
  red. ir. app union2_second. cp (equipotent_restriction H13 H6).
  assert (sub (image_by_fun x E2) (f X)). uf f.  uf image_by_fun.
  app image_by_increasing. cp (bij_is_function H6). fprops. red. ir.
  app union2_second. cp (cardinal_le8 H15). rwi cardinal_le3 H16.
  wri cardinal_equipotent H14. wri H14 H16.
  assert (cardinal E2 = cardinal E). aw. eqtrans n. am. uf n. fprops.
  rwi H17 H16. wr cardinal_equipotent. app cardinal_antisymmetry1.
  assert (transf_axioms f (powerset E) Qo). red. ir.
  rwi powerset_inc_rw H11.  uf Qo. Ztac. app powerset_inc. app H9. 
  set (F:=  BL f (powerset E) Qo). 
  assert (injective F). uf F. app injective_af_function. uf f. ir.
  cp (bij_is_function H6).
  set (T:= image_by_fun x (union2 (product u (singleton TPa)) E2)).
  set_extens. set (y := W (J x0 TPa) x).
  assert (inc (J x0 TPa) (source x)). rw H7. app union2_first. uf E1. aw. ee.  
  fprops. rwi powerset_inc_rw H12. app H12. fprops.
  assert (inc y T). uf T. uf image_by_fun. aw. exists (J x0 TPa). split. 
  app union2_first. aw. ee. fprops. am. fprops. red.  uf y. app defined_lem.
  fprops. ufi T H18. rwi H14 H18. ufi image_by_fun H18.
  awi H18. nin H18. ee. red in H19. cp (W_pr H15 H19). unfold y in H20.
  assert (inc x1 (source x)). rw H7. nin (union2_or H18).  app union2_first.
  uf E1. awi H21. ee. aw. ee.  am. rwi powerset_inc_rw H13.  app H13. am.
  app union2_second. nin H6. nin H6. symmetry in H20. cp (H23 _ _ H17 H21 H20).
  nin (union2_or H18).  awi H25.  ee. wri H24 H26. awi H26. am. ufi E2 H25.
  awi H25. ee. wri H24 H27. awi H27. cp H27.
  elim two_points_distinct. am. fprops. 
  set (y := W (J x0 TPa) x).
  assert (inc (J x0 TPa) (source x)). rw H7. app union2_first. uf E1. aw. ee.  
  fprops. rwi powerset_inc_rw H13. app H13. fprops.
  assert (inc y T). uf T. rw H14. uf image_by_fun. aw. exists (J x0 TPa). 
  split. app union2_first. aw. ee. fprops. am. fprops. red.  uf y. 
  app defined_lem. fprops. ufi T H18. ufi image_by_fun H18.
  awi H18. nin H18. ee. red in H19. cp (W_pr H15 H19). unfold y in H20.
  assert (inc x1 (source x)). rw H7. nin (union2_or H18).  app union2_first.
  uf E1. awi H21. ee. aw. ee.  am. rwi powerset_inc_rw H12.  app H12. am.
  app union2_second. nin H6. nin H6.  symmetry in H20. cp (H23 _ _ H17 H21 H20).
  nin (union2_or H18).  awi H25.  ee. wri H24 H26. awi H26. am. ufi E2 H25.
  awi H25. ee. wri H24 H27. awi H27. cp H27.
  elim two_points_distinct. am. fprops. 
  assert (cardinal_le (cardinal (powerset E)) (cardinal Qo)). red. ee.
  fprops. fprops. wr cardinal_le2. rw cardinal_le1. exists F. ee. am. uf F.
  tv. uf F. tv. wr cardinal_equipotent.
  app cardinal_antisymmetry1.
Qed.


Lemma Exercise6_4: forall E, infinite_set E ->
  equipotent (set_of_partition_set E)(powerset E).
Proof. ir.  set (q:=set_of_partition_set E).
  set (f:= BL (fun y=> partition_relation_set y E) q (powerset (coarse E))).
  assert (injective f). uf f. app injective_af_function. red. ir.
  app powerset_inc. app sub_partition_relation_set_coarse. ufi q H0. 
  ufi set_of_partition_set H0. Ztac. am. uf q. uf set_of_partition_set. ir.
  Ztac. clear H1. Ztac. sy.
  app (partition_relation_set_order_antisymmetric H4 H5).
  assert (equipotent_to_subset q (powerset (coarse E))). rw cardinal_le1.
  exists f. eee. rwi cardinal_le2 H1.
  assert (cardinal_le  (cardinal q) (cardinal (powerset (coarse E)))).
  uf cardinal_le. eee.  
  assert (cardinal (powerset (coarse E)) = cardinal (powerset E)).
  rw card_powerset. rw card_powerset.  uf coarse. app card_pow_pr. fprops.
  wr cardinal_equipotent.  wr card_mult_pr1. 
  transitivity (card_mult (cardinal E)(cardinal E)). app card_mult_pr2.
  sy. fprops. sy. fprops. wr power_x_2. app equipotent_inf2_inf. fprops.
  rwi H3 H2. nin (emptyset_dichot E). rwi H4 H. nin H. elim H5.
  rw cardinal_emptyset. wr inc_Bnat. app inc0_Bnat. nin H4.
  set (F:= complement E (singleton y)).
  set (g:= fun u => doubleton u (complement E u)).
  assert (forall u v , sub u F -> sub v F -> g u = g v -> u = v). uf g. ir.
  nin (doubleton_inj H7). nin H8. am. nin H8.
  assert (inc y F).  app H5. rw H8. srw. split. am. red. ir. 
  cp (H6 _ H10). ufi F H11. srwi H11. ee. elim H12. fprops.
  ufi F H10. srwi H10. ee. elim H11. fprops. 
  assert (forall u, sub u F -> nonempty u -> inc (g u) q). ir.
  assert (sub u E). assert (sub F E). uf F. app sub_complement. 
  app (sub_trans H6 H8).
  uf g. uf q. rw set_of_partition_pr. red. ee.  set_extens.
  nin (union_exists H9). nin H10. nin (doubleton_or H11). app H8. wrr H12.
  rwi H12 H10. srwi H10. nin H10; am.
  nin (p_or_not_p (inc x u)). ir. 
  assert (inc u (doubleton u (complement E u))). fprops. ap (union_inc H10 H11).
  ir.  assert (inc (complement E u) (doubleton u (complement E u))). fprops.
  assert (inc x (complement E u)). srw.  intuition.
  ap (union_inc H12 H11). ir. nin (doubleton_or H9). rww H10. rw H10.
  exists y. srw. split. am. red. ir. cp (H6 _ H11).
  ufi F H12. srwi H12. ee. elim H13. fprops.
  ir.  nin (doubleton_or H9); nin (doubleton_or H10); rw H11; rw H12.
  left. tv. right. app disjoint_complement.  right.
  app disjoint_symmetric. app disjoint_complement. au.

  set (T:= complement (powerset F) (singleton emptyset)).
  assert (cardinal_le(cardinal T)  (cardinal q)).
  wr cardinal_le3. rw cardinal_le1. exists (BL g T q). ee.
  app injective_af_function. red. ir. ufi T H7. srwi H7. ee.
  app H6.  app powerset_sub. nin (emptyset_dichot c).  elim H8. rw H9. fprops.
  am. ir.  ufi T H7. srwi H7.  ufi T H8. srwi H8.
  ee. app H5.  app powerset_sub. app powerset_sub.  tv. tv.
  cp (cardinal_comp_singl_inf y H). fold F in H8.
  assert (infinite_set (powerset F)). red. red.   split. fprops. red. 
  rw card_powerset. ir.
  assert (card_pow card_two F = card_pow card_two (cardinal F)). 
  app card_pow_pr. fprops.  fprops. rwi H10 H9.
  assert (is_cardinal (cardinal F)). fprops. cp (cantor  H11). nin H12.
  cp (le_int_is_int H9 H12). wri H8 H14. nin H. ee. elim H15. am.
  cp (cardinal_comp_singl_inf emptyset H9). fold T in H10. wri H10 H7.
  assert (cardinal (powerset F) = cardinal (powerset E)).
  rw card_powerset. rw card_powerset.  app card_pow_pr. fprops.
  symmetry in H8. awi H8. am. rwi H11 H7. cp (cardinal_antisymmetry1 H2 H7).
  awi H12. am.
Qed.


Lemma Cantor_Bernstein_aux2: forall (E F: Set) (f:Set -> Set) ,
  sub F E ->
  (forall x, inc x E -> inc (f x) F) ->
  (forall x y, inc x E -> inc y E -> f x = f y  -> x = y) -> 
  equipotent E F.
Proof. ir.  
  set (A := Zo (powerset E)(fun x=> forall y, inc y x -> inc (f y) x)).
  set (B:= complement E F).
  set (C:= Zo A (fun x=> sub B x)).
  set (D:= intersection C).
  assert (sub A (powerset E)). uf A. app Z_sub.
  assert (inc E C). uf C. Ztac. uf A.
  Ztac. app powerset_inc. fprops. uf B.  app sub_complement.
  assert (forall x, inc x C -> sub D x). ir. red. ir. ufi D H5.
  ap (intersection_forall H5 H4).
  assert (inc D A). uf A. Ztac. app powerset_inc. red. uf D. ir. 
  cp (intersection_forall H5 H3). am. ir. uf D. app intersection_inc.
  exists E. am. ir. assert (inc y y0). ufi D H5. 
  ap (intersection_forall H5 H6). ufi C H6.  Ztac. ufi A H7. clear H6. 
  ufi A H8. Ztac. app H10.
  assert (inc D C). uf C. Ztac. uf D. red. ir. app intersection_inc. exists E.
  am. ir. ufi C H7. Ztac. app H9.
  assert (sub B D). ufi C H6. Ztac. am.
  assert (complement E B= F). uf B. app double_complement.
  set (g:=fun y => Yo (inc y D) (f y) y).
  assert (transf_axioms g E F). red. ir. uf g. nin (inc_or_not c D).
  rww Y_if_rw. app H0. rww Y_if_not_rw. wr H8. srw. split. am.
  red. ir. elim H10. app H7.
  exists (BL g E F). ee. app bijective_af_function. ir.
  ufi g H12. nin (inc_or_not u D); [rwi Y_if_rw H12 | rwi Y_if_not_rw H12];
  nin (inc_or_not v D). rwi Y_if_rw H12. app H1. am. rwi Y_if_not_rw H12.
  elim H14. wr H12. ufi A H5. Ztac. app H16. am. am. am.
  rwi Y_if_rw H12. elim H13. rw H12. ufi A H5. Ztac. app H16. am. 
  rwi Y_if_not_rw H12. am. am. am. am.
  ir. uf g. nin (inc_or_not y D).
  assert (Ha:sub D E). ufi A H5. Ztac. app powerset_sub.
  set (T:= complement D (singleton y)). 
  assert (Hb: sub B T). red. ir. uf T. srw. split. app H7. ufi B H12.
  srwi H12. nin H12. dneg. rww (singleton_eq H14). 
  assert (~ (inc T A)). red. ir. assert (inc T C). uf C. Ztac.
  cp (H4 _ H13). ufi T H14. cp (H14 _ H11).
  srwi H15. nin H15. elim H16. fprops.  
  assert (inc T (powerset E)). app powerset_inc. apply sub_trans with D. uf T. 
  app sub_complement. am. assert (exists x, inc x T & ~ (inc (f x) T)).
  app exists_proof. red. ir. elim H12. uf A. Ztac. ir. 
  nin (inc_or_not (f y0) T). am. elim (H14 y0). au. nin H14.
  ufi T H14. nin H14. srwi H14. ee. exists x. split. app Ha. rww Y_if_rw. 
  srwi H15. nin (equal_or_not (f x) y). am. elim H15. split.
  ufi A H5. Ztac. app H19. red. ir. elim H17. app singleton_eq.
  exists y. ee. app H. rww Y_if_not_rw. tv. tv.
Qed.


End Exercise3.