

Require Import List.


Lemma list_extens: forall (A:Type) (l1 l2 : list A) (u:A),
   length l1 = length l2 -> 
   (forall i, i< length l1 -> nth i l1 u = nth i l2 u) -> l1 = l2.
Proof. 
move=> A l1. induction l1. ir. induction l2. tv. simpl in H. 
  elim (O_S _ H). ir. induction l2. simpl in H.  symmetry in H. elim (O_S _ H). 
  simpl in H. cp (eq_add_S _  _ H). cut (l1=l2). ir.
  assert (0< length (a :: l1)). simpl. red. apply le_n_S. apply le_O_n. 
  cp (H0 _ H3).  simpl in H4. ue. ue.  apply (IHl1 l2 u H1). ir.
  assert (S i < length (a :: l1)). simpl. apply lt_n_S. cp (H0 _ H3). am.
Qed.


Fixpoint fct_to_list_rev (A:Type) (f: nat->A)(n:nat): list A :=
  match n with O => nil 
    | S m => (f m) ::(fct_to_list_rev f m) end.

Definition fct_to_list A f n := rev (fct_to_list_rev (A:=A) f n).


Definition list_to_fct (a: list nat) :=
  fun n => nth n a 0.

Definition list_to_fctB (a: list Set) :=
  fun n => nth n a emptyset.

Lemma fct_to_list_length :  forall A (f:nat->A) n,
  length (fct_to_list f n) = n.
Proof. ir.  uf fct_to_list. rewrite rev_length.
  induction n. uf fct_to_list. tv. simpl. rww IHn.
Qed.

Lemma card_interval_c0_pr: forall n,
  cardinal_nat (interval_co_0a (nat_to_B n)) = n.
Proof. ir. wr cardinal_nat_cardinal.
  rewrite cardinal_interval_co_0a1. aw. fprops. 
Qed.


Lemma list_to_fct_pr0: forall a l1 l2,
  list_to_fct (l2 ++ a :: l1) (length l2) = a.
Proof. ir. uf list_to_fct. induction l2. tv. apply IHl2.
Qed.

Lemma list_to_fct_pr0B: forall a l1 l2,
  list_to_fctB (l2 ++ a :: l1)  (length l2) = a.
Proof. ir. uf list_to_fctB. induction l2. tv. apply IHl2.
Qed.

Lemma list_to_fct_pr: forall (A:Type) (f:nat->A) (u:A) n i,
  i<n -> nth i (fct_to_list f n) u = f i.
Proof. ir. cp (fct_to_list_length f n). ufi fct_to_list H0.
  rwi rev_length H0.
  uf fct_to_list. rww rev_nth. rewrite H0. clear H0.
  induction n. red in H. elim (le_Sn_O i). am. 
  change (nth (S n - S i) (f n :: fct_to_list_rev f n) u = f i).
  assert (i<=n). red in H.  autoa. nin (le_lt_or_eq _ _ H0).
  red in H1. wrr minus_Sn_m. apply IHn. rewrite H1. wrr minus_n_n. simpl. ue.
Qed.

Lemma list_to_fct_pr1: forall f n i,
  i<n -> list_to_fct (fct_to_list f n) i = f i.
Proof. ir. uf list_to_fct. apply list_to_fct_pr.  
Qed.

Lemma list_to_fct_pr1B: forall f n i,
  i<n -> list_to_fctB (fct_to_list f n) i = f i.
Proof. ir. uf list_to_fctB. apply list_to_fct_pr.  
Qed.

Lemma list_to_fct_pr3: forall l2 l1,
  fct_to_list (list_to_fct (l2++l1)) (length l2) = l2.
Proof. ir.  uf fct_to_list. cp (rev_involutive l2). wr H.
  set (l3:= rev l2) in *. clear H.  apply (f_equal (rev  (A:=  nat))).
  rewrite rev_length. generalize l1. induction l3. tv. 
  ir. assert (rev (a :: l3) ++ l0 = rev l3 ++ (a::l0)). simpl. rww app_ass. 
  rewrite H. simpl.  rewrite IHl3.  wr (rev_length l3). rww list_to_fct_pr0. 
Qed.

Lemma list_to_fct_pr4: forall l,
  fct_to_list (list_to_fct l) (length l) = l.
Proof. ir. cp (list_to_fct_pr3 l nil). wri app_nil_end H. am.
Qed.

Lemma list_to_fct_pr3B: forall l2 l1,
  fct_to_list (list_to_fctB (l2++l1)) (length l2) = l2.
Proof. ir. uf fct_to_list. cp (rev_involutive l2). wr H.
  set (l3:= rev l2) in *. clear H.  apply (f_equal (rev  (A:= Set))).
  rewrite rev_length. generalize l1. induction l3. tv. 
  ir. assert (rev (a :: l3) ++ l0 = rev l3 ++ (a::l0)). simpl. rww app_ass. 
  rewrite H. simpl.  rewrite IHl3.  wr (rev_length l3). rww list_to_fct_pr0B. 
Qed.

Lemma list_to_fct_pr4B: forall l,
  fct_to_list (list_to_fctB l) (length l) = l.
Proof. ir. cp (list_to_fct_pr3B l nil).  wri app_nil_end H. am.
Qed.

Lemma fct_to_list_unique: forall (A:Type) (f g: nat-> A) n,
  (forall i, i< n -> f i = g i) -> fct_to_list f n = fct_to_list g n.
Proof. intros A f g n. induction n. ir. tv. ir. 
  uf fct_to_list.  apply (f_equal (rev  (A:= A))).
  simpl. rewrite (H n);try auto.  assert (forall i : nat, i < n -> f i = g i).
  ir. apply H. auto. cp (f_equal  (rev (A:=A)) (IHn H0)). 
  ufi fct_to_list  H1. rwi rev_involutive H1.  rwi rev_involutive H1. rww H1.
Qed.


Lemma app_nth3 : forall A (a:A),
  forall l' d n, n >= 1 -> nth n (a::l') d = nth (n-1) l' d.
Proof. ir. set (l:= a::nil).  assert (a :: l' = l++l'). uf l. tv.
  rewrite H0. assert (length l=1). uf l. tv. wr H1. apply app_nth2.
Qed.

Lemma fct_to_rev: forall (A:Type) (f:nat->A) n, 
  rev (fct_to_list f n) =  fct_to_list (fun i=> f(n-i-1)) n.
Proof.  ir. apply list_extens with (u:=f 0). rewrite rev_length. 
  do 2 rewrite fct_to_list_length. tv.
  rewrite rev_length. rewrite fct_to_list_length. ir.
  rewrite rev_nth. assert (length (fct_to_list f n) - S i = 
  length (fct_to_list f n) - i -1). rewrite fct_to_list_length. apply plus_minus.
  sy. apply plus_minus. rewrite plus_assoc. wr (Sn_is_plus1 i). apply le_plus_minus.
  rewrite H0. rewrite fct_to_list_length. rww list_to_fct_pr.
  cp (double_compl_nat H). rww list_to_fct_pr. apply double_compl_ex.
  rww fct_to_list_length.
Qed.

Definition list_to_f (l: list nat):=
  BL (fun n => nat_to_B (list_to_fct l (cardinal_nat n)))
  (interval_co_0a  (nat_to_B (length l))) Bnat.

Definition list_to_fB (l: list Set) E:=
  BL (fun n => list_to_fctB l (cardinal_nat n))
  (interval_co_0a  (nat_to_B (length l))) E.


Lemma list_to_f_axioms: forall (l: list nat),
  transf_axioms (fun n => (nat_to_B (list_to_fct l (cardinal_nat n))))
  (interval_co_0a  (nat_to_B (length l))) Bnat.
Proof. ir. red.  ir. fprops.
Qed.

Lemma list_to_f_function: forall (l: list nat),
  is_function (list_to_f l).
Proof. ir. uf list_to_f. apply bl_function. apply list_to_f_axioms.
Qed.

Lemma list_to_f_W: forall (l: list nat) n,
  inc n (interval_co_0a (nat_to_B (length l))) ->
  W n (list_to_f l) = nat_to_B (list_to_fct l (cardinal_nat n)).
Proof. ir. uf list_to_f. rewrite bl_W. tv. apply list_to_f_axioms. am.
Qed.

Lemma list_to_f_W1: forall (l: list nat) n,
  n < length l ->
  W (nat_to_B n) (list_to_f l) = nat_to_B (list_to_fct l n).
Proof. ir. cp (nat_to_B_pr1 n). set (m:=nat_to_B n). fold m in H0.
  wr H0. apply list_to_f_W. srw. ee. uf m. fprops. uf m. bw. fprops.
Qed.
  
Lemma list_to_f_W2: forall (l: list nat) n,
  n < length l ->
  cardinal_nat(W (nat_to_B n) (list_to_f l)) = list_to_fct l n.
Proof. ir. rww  list_to_f_W1. aw. 
Qed.

Definition back_to_nat f n:= 
  cardinal_nat (Yo (inc (nat_to_B n) (source f))
    (W (nat_to_B n) f) card_zero).

Lemma back_to_nat_pr: forall f n,  inc  (nat_to_B n) (source f) ->
  back_to_nat f n =  cardinal_nat (W  (nat_to_B n) f).
Proof. ir. uf back_to_nat. rewrite Y_if_rw. tv. am.
Qed.
  
Lemma back_to_nat_pr1: forall f n k,
  source f = (interval_co_0a (nat_to_B k)) ->
  n < k -> back_to_nat f n =  cardinal_nat (W (nat_to_B n) f).
Proof. ir. apply  back_to_nat_pr.  rewrite H. srw. ee. fprops. bw. fprops.
Qed.
  
Lemma back_to_nat_pr2: forall (l: list nat) n,
  n < (length l) -> back_to_nat (list_to_f l) n = list_to_fct l n.
Proof. ir. 
  assert (source (list_to_f l) =  (interval_co_0a (nat_to_B (length l)))).
  uf list_to_f. aw. rewrite (back_to_nat_pr1 H0  H). 
  rww list_to_f_W1. aw.
Qed.

Lemma list_to_f_pr1: forall f n, is_function f -> target f = Bnat ->
  source f = (interval_co_0a (nat_to_B n)) ->
  f = list_to_f (fct_to_list (back_to_nat f) n).
Proof. ir. set (ll:=fct_to_list (back_to_nat f) n).
  assert (length ll = n). uf ll. rww fct_to_list_length.
  apply function_exten. ee. apply list_to_f_function.
  uf list_to_f. aw. ue.  uf list_to_f. aw.
  ir. assert (Ha: inc (W x f) Bnat).
  wr H0.  fprops. rwi H1 H3. cp (sub_interval_co_0a_Bnat H3).
  cp (nat_to_B_pr H4).  srwi H3. wri H5 H3. bwi H3.
  wr H5. rww list_to_f_W1. uf ll.  rww list_to_fct_pr1.
  rww (back_to_nat_pr1 H1 H3). rewrite H5. aw. rww H2. fprops.
Qed.

Lemma list_to_f_pr2: forall l, 
  fct_to_list (back_to_nat (list_to_f l)) (length l) = l.
Proof. ir. wr list_to_fct_pr4. apply fct_to_list_unique. ir.
  apply back_to_nat_pr2.
Qed.

Inductive list_prop (A:Type)  (q: A->Prop) : list A -> Prop :=
  | list_prop_nil: list_prop  q nil
  | list_prop_cons: forall (a:A)(l:list A),
    q a -> list_prop q l -> list_prop q (a::l).


Lemma list_prop1: forall A (q: A->Prop),  list_prop q nil. 
Proof. ir. left. Qed.

Lemma list_prop2: forall A a b (q: A->Prop),  
  q a -> (list_prop q b) = (list_prop q (a::b)).
Proof. ir. apply iff_eq.  ir. right;am. ir. inversion H0. am.
Qed. 

Lemma list_prop3: forall A a b (q: A->Prop),  
  ~ (q a) -> ~(list_prop q (a::b)).
Proof. ir. simpl. red. ir.  inversion H0. contradiction. 
Qed. 

Lemma list_prop_app: forall A a b (q: A->Prop),  
  (list_prop q a) -> (list_prop q b) 
  -> (list_prop q (a++b)).
Proof. ir. induction a. simpl. am. simpl. inversion H.  right. am.  apply IHa. 
Qed.

Lemma list_prop_refine: forall A L (p q: A->Prop), 
  (forall a, p a -> q a) ->  list_prop p L ->  list_prop q L.
Proof. ir. induction L. left. inversion H0. right. apply H. apply IHL.
Qed.

Lemma list_prop_nth: forall  A (q: A->Prop) L u n,
  list_prop q L -> n < length L ->
  q (nth n L u).
Proof. intros A q L. induction L. ir. simpl in H0. elim (le_Sn_O n). am.
  intros u n rec. inversion rec. case n. ir. am.
  ir.  simpl. apply IHL.  simpl in H3. autoa.
Qed.


Definition list_subset L E := list_prop (fun x => inc x E) L.

Fixpoint contraction (A B: Type) (L: list A) (f: A-> B->B) (v: B):B :=
  match L with | nil => v
    | a :: b => f a (contraction b f v) end.

Definition list_range l := contraction l (fun a b => tack_on b a) emptyset.

Lemma list_range_pr: forall L, list_subset L (list_range L).
Proof. ir. uf list_subset. induction L.  left. right.
  uf list_range. simpl. fprops. 
  assert (forall x, inc x (list_range L) -> inc x (tack_on (list_range L) a)).
  ir. fprops. apply (list_prop_refine _ H IHL).
Qed. 

Lemma list_range_pr1: forall L E, list_subset L E -> sub (list_range L) E.
Proof. ir. ufi list_subset H. induction L.  uf list_range. simpl. 
  apply emptyset_sub_any. uf list_range. simpl. inversion H.
  red. ir. rwi tack_on_inc H4. nin H4. apply IHL. rww H4.
Qed. 

Lemma list_to_fB_axioms: forall l E, list_subset l E ->
  transf_axioms (fun n => (list_to_fctB l (cardinal_nat n)))
  (interval_co_0a  (nat_to_B (length l))) E.
Proof. ir. red. ir.  wri (nat_to_B_pr (sub_interval_co_0a_Bnat H0)) H0. 
  srwi  H0. bwi H0. uf list_to_fctB. red in H.
  apply list_prop_nth. fprops.
Qed.

Lemma list_to_fB_function:  forall l E, list_subset l E ->
  is_function (list_to_fB l E).
Proof. ir. uf list_to_fB. apply bl_function. apply list_to_fB_axioms.
Qed.

Lemma list_to_fB_W: forall l E n, list_subset l E ->
  inc n (interval_co_0a (nat_to_B (length l))) ->
  W n (list_to_fB l E) = list_to_fctB l (cardinal_nat n).
Proof.
  ir. uf list_to_fB. rewrite bl_W. tv. apply list_to_fB_axioms. am.
Qed.

Lemma list_to_fB_W1: forall  l E n, list_subset l E ->
  n < length l ->
  W (nat_to_B n) (list_to_fB l E) = list_to_fctB l n.
Proof. ir. set (m:=nat_to_B n).  wr (nat_to_B_pr1 n). 
  apply list_to_fB_W. srw. bw. fprops.
Qed.

Lemma length_app1: forall (A:Type) (a:A) l l',
  length l < length (l ++ a :: l').
Proof. ir. rewrite app_length. 
  simpl. rewrite plus_comm. rewrite plus_Snm_nSm. red. apply le_plus_r.
Qed.

Lemma length_app2:  forall (A:Type) (a:A) l ,
  nat_to_B (length (l++a::nil)) = succ (nat_to_B (length l)).
Proof.  ir. rewrite app_length. simpl. bw. rww plus_comm. 
Qed.

Lemma list_to_f_cons0: forall a l l',
  W (nat_to_B  (length l)) (list_to_f (l++ a:: l')) = nat_to_B a.
Proof. ir. rewrite list_to_f_W1. rww list_to_fct_pr0. apply length_app1.
Qed.

Lemma list_to_f_cons1: forall a l l' n, n < length l ->
  W (nat_to_B n) (list_to_f (l ++ a :: l')) =  W (nat_to_B n) (list_to_f l).
Proof. ir. rewrite list_to_f_W1.  rww list_to_f_W1. uf list_to_fct. 
  rww app_nth1. rewrite app_length. apply lt_plus_trans.  
Qed.

Lemma list_to_f_cons2: forall a l l',
  list_to_f l = restriction (list_to_f (l++ a :: l'))  
               (interval_co_0a (nat_to_B (length l))).
Proof. ir. set (n:=  nat_to_B(length l)). 
  assert(sub (interval_co_0a n) (source (list_to_f (l ++ a :: l')))).
  uf list_to_f. aw. apply interval_co_0a_increasing1. uf n. fprops. fprops.
  rewrite app_length. uf n. bw. apply le_plus_l.
  assert (is_function (list_to_f (l ++ a :: l'))). apply list_to_f_function. 
  apply function_exten. apply list_to_f_function.
  apply restriction_function. uf list_to_f. uf restriction. aw.
  uf list_to_f. uf restriction. aw. ir.
  ufi list_to_f H1. ufi restriction H1. awi H1.
  rww restriction_W. sy. simpl in H1.
  cp (nat_to_B_pr (sub_interval_co_0a_Bnat H1)). wr H2.
  apply list_to_f_cons1.  aw. srwi H1. am. fprops. wr H2.  fprops. 
Qed.

Lemma list_to_f_cons3: forall a l,
  list_to_f (l++a::nil) = tack_on_f (list_to_f l)
  (nat_to_B (length l))  (nat_to_B a).
Proof. ir. set (N:= nat_to_B (length l)).
  assert (Ha:is_function (list_to_f l)). apply list_to_f_function.
  assert (Hb:inc N Bnat). uf N. fprops.
  cp  (length_app2 a l). 
  nin (interval_co_pr4 Hb). 
  apply function_exten. apply list_to_f_function.
  apply tack_on_function. uf list_to_f. uf restriction. aw.
  uf list_to_f. uf tack_on_f. aw. sy. rww H.  
  uf list_to_f. uf tack_on_f. aw. sy. apply tack_on_when_inc. fprops.
  ir.  ufi list_to_f H2.  awi H2. rwi H H2.
  ir. cp (nat_to_B_pr (sub_interval_co_0a_Bnat H2)). 
  fold N in H2. wri H0 H2. rwi tack_on_inc H2. wr H3. nin H2. rww tack_on_W_in. 
  apply list_to_f_cons1. aw. srwi H2. am. am. 
  wr H3. fprops.  uf list_to_f. aw. rww H3.  uf list_to_f. aw.
  assert (cardinal_nat N = length l). uf N. aw. rewrite H2. rewrite H4.
  rww list_to_f_cons0.  rww tack_on_W_out.  uf list_to_f. aw.
Qed.

Lemma list_subset_cons: forall a l l' E, list_subset l E -> inc a E ->
  list_subset l' E ->
  list_subset (l'++a::l) E.
Proof. induction l'. ir. simpl. right. am. am. 
  ir. inversion H1. wr app_comm_cons. right. am. apply IHl'.
Qed.

Hint Resolve list_subset_cons: fprops.

Lemma list_to_f_consB0: forall a l l' E, 
  list_subset l E -> inc a E -> list_subset l' E ->
  W (nat_to_B  (length l)) (list_to_fB (l++ a:: l') E) = a.
Proof. ir. rewrite list_to_fB_W1. rww list_to_fct_pr0B. fprops. apply length_app1.
Qed.

Lemma list_to_f_consB1: forall a l l' n E, n< length l -> 
  list_subset l E -> inc a E ->  list_subset l' E ->
  W (nat_to_B n) (list_to_fB (l++ a :: l') E) = W (nat_to_B n) (list_to_fB l E).
Proof. ir. repeat rewrite list_to_fB_W1. uf list_to_fctB.
  rww app_nth1. am. am. fprops. rewrite app_length. apply lt_plus_trans.  
Qed.

Lemma list_to_f_consB2: forall a l l' E,
  list_subset l E -> inc a E ->  list_subset l' E ->
  list_to_fB l E = restriction (list_to_fB (l++ a :: l') E)  
               (interval_co_0a (nat_to_B (length l))).
Proof. ir. set (n:=  nat_to_B(length l)). 
  assert(sub (interval_co_0a n) (source (list_to_fB (l ++ a :: l') E))).
  uf list_to_fB. aw. apply interval_co_0a_increasing1. uf n. fprops. fprops.
  rewrite app_length. uf n. bw. apply le_plus_l.
  assert (is_function (list_to_fB (l ++ a :: l') E)).
    apply list_to_fB_function. fprops.
  apply function_exten. apply list_to_fB_function.
  apply restriction_function. uf list_to_fB. uf restriction. aw.
  uf list_to_fB. uf restriction. aw.
  ir.  ufi list_to_fB H4. ufi restriction H4.  awi H4.
  rww restriction_W. sy.
  cp (nat_to_B_pr (sub_interval_co_0a_Bnat H4)). wr H5.
  apply list_to_f_consB1.  aw. srwi H4. am. fprops. wr H5. fprops. 
Qed.

Lemma list_to_f_consB3: forall a l E,
  list_subset l E -> inc a E ->
  list_to_fB (l++a::nil) E 
  = tack_on_f  (list_to_fB l E) (nat_to_B (length l))  a.
Proof. ir.  ir. set (N:= nat_to_B (length l)).
  assert (Ha:is_function (list_to_fB l E)). apply list_to_fB_function.
  assert (Hb:inc N Bnat). uf N. fprops.
  assert (Hc:list_subset nil E). left. fprops.
  cp (length_app2 a l).
  nin (interval_co_pr4 Hb). 
  apply function_exten. apply list_to_fB_function. fprops.
  apply tack_on_function. uf list_to_fB. aw.  uf list_to_fB. uf tack_on_f. aw.
  fold N. rewrite H1. sy. am.   uf list_to_fB. uf tack_on_f. aw.
  sy. apply tack_on_when_inc. fprops. ir. ufi list_to_fB H4. awi H4.
  rwi H1 H4. cp (nat_to_B_pr (sub_interval_co_0a_Bnat H4)). 
  fold N in H4. wri H2 H4. rwi tack_on_inc H4. wr H5. nin H4. rww tack_on_W_in. 
  apply list_to_f_consB1. aw. srwi H4. am. am. 
  wr H5. fprops.  uf list_to_fB. aw.  uf list_to_fB. aw. wr H5. fprops.
  assert (cardinal_nat x = length l).  rewrite H4.  uf N. aw. rewrite H6.
  rww list_to_f_consB0. wr H6. rww H5. rewrite H4.  rww tack_on_W_out.
  uf list_to_fB. aw.  
Qed.


Definition fct_to_listB1 f n:= 
  fct_to_list (fun n => W (nat_to_B n) f) n.

Definition fct_to_listB f := fct_to_listB1 f (cardinal_nat (source f)).
Definition iid_function f :=
  is_function f & exists n, source f = interval_co_0a (nat_to_B n).

Lemma fct_to_list_lengthB :  forall f,  iid_function f -> 
  nat_to_B (length (fct_to_listB f)) = cardinal (source f).
Proof. ir. nin H. nin H0. uf fct_to_listB. rewrite H0. rewrite card_interval_c0_pr.
  uf fct_to_listB1. rewrite fct_to_list_length.
  rww  cardinal_interval_co_0a1. fprops.
Qed.

Lemma list_to_fB_pr:  forall l E, list_subset l E ->
  iid_function (list_to_fB l E).
Proof. ir. split. apply list_to_fB_function. uf list_to_fB. aw.
  exists (length l). tv.
Qed.

Lemma fct_to_listB_pr0: forall f i,
  iid_function f -> i< cardinal_nat (source f) -> 
  list_to_fctB (fct_to_listB f) i = W (nat_to_B i) f.
Proof. ir. uf fct_to_listB. uf fct_to_listB1. uf list_to_fctB. 
  rww list_to_fct_pr.
Qed.

Lemma fct_to_listB_pr1: forall l E, list_subset l E ->
  fct_to_listB (list_to_fB l E) = l.
Proof. ir.  uf fct_to_listB. uf list_to_fB. aw.
  rewrite card_interval_c0_pr. uf fct_to_listB1. 
  set (l1:=fct_to_list (fun n => W (nat_to_B n) (list_to_fB l E)) (length l)).
  assert (length l1 = length l). uf l1. apply fct_to_list_length.
  apply (list_extens l1 l emptyset). ir. rwi H0 H1.
  uf l1. rewrite list_to_fct_pr. rww list_to_fB_W. aw. srw. bw. fprops. am.
Qed.

Lemma fct_to_listB_pr2: forall f, iid_function f ->
   list_subset (fct_to_listB f) (target f).
Proof. ir. red in H. ee. nin H0. uf fct_to_listB. rewrite H0. 
  rewrite card_interval_c0_pr. uf fct_to_listB1.
  set (E:= target f). 
  assert (forall n , n< x -> inc (W (nat_to_B n) f) E). ir. uf E.
  apply inc_W_target. rewrite H0. srw. bw. fprops.
  clear H0.
  induction x. simpl. uf list_subset. uf fct_to_list. simpl. left.
  uf fct_to_list. simpl.
  apply list_subset_cons. left. apply H1. auto. apply IHx. ir.  apply H1. autoa. 
Qed.

Lemma fct_to_listB_pr3: forall f, iid_function f ->
  list_to_fB  (fct_to_listB f) (target f) = f.
Proof. ir. cp (fct_to_listB_pr2 H). nin H. nin H1.
  assert (interval_co_0a (nat_to_B (length (fct_to_listB f))) = source f).
  uf fct_to_listB. uf fct_to_listB1. rewrite fct_to_list_length.  
  rewrite H1. rww card_interval_c0_pr.
  apply function_exten. apply list_to_fB_function.
  uf list_to_fB. aw. uf list_to_fB. aw. ir.  ufi list_to_fB H3. awi H3. ir.
  rww list_to_fB_W.
  uf fct_to_listB. uf fct_to_listB1. rwi H2 H3. rwi H1 H3.
  cp  (sub_interval_co_0a_Bnat H3).
  rewrite list_to_fct_pr1B. aw.  rewrite H1. rewrite card_interval_c0_pr. 
  srwi H3. rww nat_B_lt. aw. fprops.
Qed.

